import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.util.*;


//CLASE QUE CARGA CONTENIDO HTML, EMPLEADA PARA LA SECCIONES DE TEORA Y AYUDA
public class BloqueHTML extends JTextPane
{
	private int offset;
	private DefaultStyledDocument doc;
	
	public BloqueHTML(String textoHTML)
	{
		super();
		
		setBackground(new Color(249,249,249));	
		setEditable(false);		//creamos la clase StyleContext en la que nos apoyaremos
	
		doc = new DefaultStyledDocument();
		
		//Asociamos el documento a este JTextPane
		setStyledDocument(doc);
		
		//Especificamos el tipo de contenido que va a contener
		setContentType("text/html");

		//Insertamos el texto HTML que se le ha pasado al contructor como parmetro de entrada
		setText(textoHTML);
	}

	
	//Sobreescribe el mtodo paintComponent para que suavice el texto que contiene
	public void paintComponent(Graphics g)
	{
		if (g instanceof Graphics2D)
		{
      			Graphics2D g2 = (Graphics2D)g;
      			Map<Object, Object> rMap = new HashMap<Object, Object>();
        		Object key = RenderingHints.KEY_ANTIALIASING;
        		Object value = RenderingHints.VALUE_ANTIALIAS_ON;
        		rMap.put(key, value);
        		g2.addRenderingHints(rMap);
    	}
    	super.paintComponent(g);	
	}
}