import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.font.*;

//CLASE QUE DEFINE EL BOTN "SIMULAR SLOT"
public class BotonSlot extends Boton
{
	private int numeroSlots;
	
	public BotonSlot(ImageIcon icono, ImageIcon iconoPressed, ImageIcon iconoDisabled, MouseListener listener)
	{
		super(icono, iconoPressed, iconoDisabled, listener);
		numeroSlots=1;
	}
	

	public void setNumeroSlots(int numeroSlots)
	{
		this.numeroSlots=numeroSlots;
		repaint();
	}
	
	public int getNumeroSlots()
	{
		return numeroSlots;
	}
	
	public void paintComponent(Graphics g)
	{

		super.paintComponent(g);
			
		Graphics2D graphics2d = (Graphics2D)g;
		Font fuente=new Font("Arial", Font.BOLD, 11);
		graphics2d.setFont(fuente);
		
		//Vamos a escribir centrado y suavizado el nmero de slots que el botn simular 
		//Se calcula el espacio que ocupar el texto final, abreviando la palabra "cantidad" en caso necesario para que la expresin quepa en el botn
		graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		FontRenderContext frc = graphics2d.getFontRenderContext();
		String texto="cantidad: "+numeroSlots;
		LineMetrics linemetrics = fuente.getLineMetrics(texto, frc);
		int largo = (int)fuente.getStringBounds(texto, frc).getWidth();
		
		if (largo>=getIcon().getIconWidth())
		{
			texto="cant: "+numeroSlots;
			linemetrics = fuente.getLineMetrics(texto, frc);
			largo = (int)fuente.getStringBounds(texto, frc).getWidth();
			if (largo>=getIcon().getIconWidth())
			{
				texto=""+numeroSlots;
				linemetrics = fuente.getLineMetrics(texto, frc);
				largo = (int)fuente.getStringBounds(texto, frc).getWidth();
				
			}
		}
		
		//Escribimos la espresin que hemos calculado centrada en el botn.
		int desfaseX=(getIcon().getIconWidth()-largo)/2;
		graphics2d.drawString(texto, desfaseX, getIcon().getIconHeight()-2);
	}
}
