import java.util.*;
import java.awt.Color;

//CLASE QUE IMPLEMENTA LA ESTACIN DE LA VERSIN 1
public class EstacionVersion1 extends Estacion
{	
		
	//CONSTRUCTOR
	public EstacionVersion1(int idEstacion, double pg, int numeroEstaciones, int version)
	{
		super(idEstacion, pg, numeroEstaciones, version);
	}
	
	//sobreescribe el mtodo comprobarSiDatosSonAceptados de la clase abstracta Estacion
	public int comprobarSiDatosSonAceptados()
	{	
		int nuevoEstado;
		
		//Si el usuario no gener datos:
		if(datosGeneradosPorUsuario==null) return USUARIO_NO_HA_ENVIADO_DATOS;
		
		//Si el usuario s gener datos se determina el destino de los mismos
		int destino=datosGeneradosPorUsuario.getDestino();
	
		int idBus=(destino>idEstacion? 0: 1);

		//Si el Control de Acceso destino no tiene datos pendientes de envo acepta los datos	
		if(datosPendientes[idBus]==null)
		{
			datosPendientes[idBus]=datosGeneradosPorUsuario;
			incrementarDatosAceptados(idBus);
			nuevoEstado=(idBus==0? CA1_ACEPTA_DATOS: CA2_ACEPTA_DATOS);
		}
		
		//Si el Control de Acceso destino tiene datos pendientes de envo rechaza los datos	
		else
		{
			incrementarDatosRechazados(idBus);
			nuevoEstado=(idBus==0? CA1_RECHAZA_DATOS: CA2_RECHAZA_DATOS);
		}
	
		estado.add(nuevoEstado);
		return nuevoEstado;
	}
	

	//Sobreescribe el mtodo comprobarSiCeldaContieneDatos de la clase abstracta Estacion
	public int comprobarSiCeldaContieneDatos(int idBus)
	{
		//Si la celda de entrada es null significar que no se recibi celda alguna
		if(celdaEntrada[idBus-1]==null) return (idBus==1? CA1_CELDA_NO_RECIBIDA: CA2_CELDA_NO_RECIBIDA);
			
		//Si la celda de entrada contiene datos y no han sido introducidos por esta estacin se envan lso datos al usuario
		if (celdaEntrada[idBus-1].getOcupada()) 
		{
			int nuevoEstado=(idBus==1? CA1_ENVIA_DATOS_A_USUARIO: CA2_ENVIA_DATOS_A_USUARIO);
			estado.add(nuevoEstado);
			return nuevoEstado;
		}
		//Si se recibi una celda pero no contena datos entonces est vaca
		return (idBus==1? CA1_RECIBIDA_CELDA_VACIA: CA2_RECIBIDA_CELDA_VACIA);
	}
	
	
	//Sobreescribe el mtodo comprobarDatosPendientesCA de la clase abstracta Estacion
	public int comprobarDatosPendientesCA(int idBus)
	{
		Datos datosPendientes=this.datosPendientes[idBus-1];

		//establecemos las celdas de salida
		 celdaSalida[idBus-1]=(celdaEntrada[idBus-1]!=null? celdaEntrada[idBus-1].clonar(): null);
		
		//Si no hay celda de salida
		if (celdaSalida[idBus-1]==null) 
		{
			return (idBus==1? CA1_NO_TIENE_CELDA: CA2_NO_TIENE_CELDA);
		}
		
		//Si hay celda de salida y el CA tiene datos pendientes
		if (datosPendientes!=null)
		{
			//Si la celda est vaca y el contador CD es menor o igual que cero inserta los datos
			if (!celdaSalida[idBus-1].getOcupada())
			{
				if (version==1 || version==2)
				{
					celdaSalida[idBus-1].setDatos(datosPendientes);
					this.datosPendientes[idBus-1]=null;
					incrementarDatosCursados(idBus-1);
					return (idBus==1? CA1_INSERTA_DATOS: CA2_INSERTA_DATOS);
				}
			}
			//Si haba datos pendientes y la celda estaba ocupada se incrementa el tiempo de servicio
			else
			{
				incrementarTiempoDeServicio(idBus-1);
				return (idBus==1? CA1_NO_PUEDE_INSERTAR_DATOS: CA2_NO_PUEDE_INSERTAR_DATOS);
			}
		}
		
		//Si el CA no tiene datos pendientes:
		return (idBus==1? CA1_NO_TIENE_DATOS_PENDIENTES:CA2_NO_TIENE_DATOS_PENDIENTES);	
	}
	
	
	
	//SOBREESCRIBIMOS LOS MTODOS QUE CORRESPONDEN A OTRAS VERSIONES, DEJNDOLOS VACOS
	public int borrarCelda(int idBus)
	{	
		return -1;
	}

	
	public int comprobarSolicitudEnvioDePeticion(int idBus)
	{
		return -1;
	}
	
	public int comprobarEnvioDePeticion(int idBus)
	{
		return -1;
	}
	
	public int comprobarEnvioRC(int idBus)
	{
		return -1;		
	}
	
	
	public Datos getDatosPendientes(int idBus) 
	{
		return datosPendientes[idBus-1];
	}
	
	public boolean contabilizarCeldaVacia(int idBus)
	{
		return false;
	}
	
	
	public int[] getContadorVacias()
	{
		return null;
	}
	
	public int[] getContadorPeticiones()
	{
		return null;
	}
	
	public int[] getCuentaAtras()
	{
		return null;
	}
	
	public int getContadorVacias(int idBus) 
	{
		return -1;
	}
	
	public int getContadorPeticiones(int idBus) 
	{
		return -1;
	}
	
	public int getCuentaAtras(int idBus) 
	{
		return -1;
	}	
}
