import java.util.Hashtable;
import java.awt.Image;
import javax.swing.Icon;
import java.awt.Cursor;


//CLASE QUE IMPLEMENTA LA FACTORA DE OBJETOS MULTIMEDIA, QUE CONTIENE TANTO LAS IMAGENES COMO LAS REFERENCIAS A LOS ARCHIVOS DE AUDIO ASOCIADOS A AQUELLOS EVENTOS DE LAS ESTACIONES PARA LOS QUE BloqueGrafico y BloqueAudio REQUIEREN UNA IMAGEN O UN SONIDO, RESPECTIVAMENTE
public class FactoriaMultimedia
{
	private String directorioAudio=Constantes.directorioAudio;
	private static FactoriaMultimedia factoria;
	private CargadorDeImagenes cargador;
	private static Hashtable<String, Image> imagenes;
	private static Hashtable<String, Image> imagenesEstaticas;
	private static Hashtable<String, String> sonidos;	
	private static Hashtable<String, Icon> iconos;
	
	
	//Los cursores que emplea la aplicacin. Cambindolos aqu se cambiarn en toda la aplicacin automticamente.
	public static Cursor cursorDefault=CargadorDeImagenes.getCargador().getCursor("cursorDefault.gif");
	public static Cursor cursorHand=CargadorDeImagenes.getCargador().getCursor("cursorHand.gif");
	public static Cursor cursorMostrarSeleccionadas=CargadorDeImagenes.getCargador().getCursor("cursorMostrar.gif");
	public static Cursor cursorOcultarSeleccionadas=CargadorDeImagenes.getCargador().getCursor("cursorOcultar.gif");
	public static Cursor cursorSeleccionarAudio=CargadorDeImagenes.getCargador().getCursor("cursorAudio.gif");
	public static Cursor cursorSeleccionarTexto=CargadorDeImagenes.getCargador().getCursor("cursorTexto.gif");
	public static Cursor cursorWait=CargadorDeImagenes.getCargador().getCursor("cursorWait.gif");
		
	
	private FactoriaMultimedia()
	{
		cargador=CargadorDeImagenes.getCargador();
		imagenes=new Hashtable<String, Image>();
		imagenesEstaticas=new Hashtable<String, Image>();
		sonidos=new Hashtable<String, String>();
	
	
		//Cargamos las imgenes animadas asociadas a los eventos que nos interesan (sern solicitadas por BloqueGafico)
		imagenes.put(""+Estacion.USUARIO_GENERA_DATOS_CA1, cargador.getImagen("usuarioGenera.gif"));
		imagenes.put(""+Estacion.USUARIO_GENERA_DATOS_CA2, cargador.getImagen("usuarioGenera.gif"));
		imagenes.put(""+Estacion.USUARIO_NO_GENERA_DATOS, cargador.getImagen("usuarioNoGenera.gif"));
		imagenes.put(""+Estacion.CA1_ACEPTA_DATOS, cargador.getImagen("CA1DatosAceptados.gif"));
		imagenes.put(""+Estacion.CA2_ACEPTA_DATOS, cargador.getImagen("CA2DatosAceptados.gif"));
		imagenes.put(""+Estacion.CA1_MARCA_TX_PENDIENTE, cargador.getImagen("CA1TxPendiente.gif"));
		imagenes.put(""+Estacion.CA2_MARCA_TX_PENDIENTE, cargador.getImagen("CA2TxPendiente.gif"));
		imagenes.put(""+Estacion.CA1_RECHAZA_DATOS, cargador.getImagen("CA1DatosRechazados.gif"));
		imagenes.put(""+Estacion.CA2_RECHAZA_DATOS, cargador.getImagen("CA2DatosRechazados.gif"));
		imagenes.put(""+Estacion.CA1_ENVIA_DATOS_A_USUARIO, cargador.getImagen("CA1aUsuario.gif"));
		imagenes.put(""+Estacion.CA2_ENVIA_DATOS_A_USUARIO, cargador.getImagen("CA2aUsuario.gif"));
		imagenes.put(""+Estacion.CA1_INSERTA_DATOS, cargador.getImagen("CA1InsertaDatos.gif"));
		imagenes.put(""+Estacion.CA2_INSERTA_DATOS, cargador.getImagen("CA2InsertaDatos.gif"));
		imagenes.put(""+Estacion.CA1_INSERTA_DATOS_V3V4, cargador.getImagen("CA1InsertaDatos.gif"));
		imagenes.put(""+Estacion.CA2_INSERTA_DATOS_V3V4, cargador.getImagen("CA2InsertaDatos.gif"));
		imagenes.put(""+Estacion.CA1_BORRA_DATOS, cargador.getImagen("borrarCA1.gif"));
		imagenes.put(""+Estacion.CA2_BORRA_DATOS, cargador.getImagen("borrarCA2.gif"));
		imagenes.put(""+Estacion.CA1_SOLICITA_ENVIO_DE_PETICION, cargador.getImagen("CA1SolicitaEnvioDePeticion.gif"));
		imagenes.put(""+Estacion.CA2_SOLICITA_ENVIO_DE_PETICION, cargador.getImagen("CA2SolicitaEnvioDePeticion.gif"));
		imagenes.put(""+Estacion.CA1_ENVIA_RC, cargador.getImagen("CA1enviaRC.gif"));
		imagenes.put(""+Estacion.CA2_ENVIA_RC, cargador.getImagen("CA2enviaRC.gif"));
		
		//Cargamos las imgenes fijas (no animadas) asociadas a los eventos que nos interesan (sern solicitadas por BloqueGafico)
		imagenesEstaticas.put(""+Estacion.CA1_ACEPTA_DATOS, cargador.getImagen("CA1DatosAceptadosFija2.gif"));
		imagenesEstaticas.put(""+Estacion.CA2_ACEPTA_DATOS, cargador.getImagen("CA2DatosAceptadosFija2.gif"));
		imagenesEstaticas.put(""+Estacion.CA1_RECHAZA_DATOS, cargador.getImagen("CA1DatosRechazadosFija2.gif"));
		imagenesEstaticas.put(""+Estacion.CA2_RECHAZA_DATOS, cargador.getImagen("CA2DatosRechazadosFija2.gif"));
		imagenesEstaticas.put(""+Estacion.CA1_ENVIA_DATOS_A_USUARIO, cargador.getImagen("CA1aUsuarioFija2.gif"));
		imagenesEstaticas.put(""+Estacion.CA2_ENVIA_DATOS_A_USUARIO, cargador.getImagen("CA2aUsuarioFija2.gif"));
		imagenesEstaticas.put(""+Estacion.CA1_BORRA_DATOS, cargador.getImagen("borrarCA1Fija.gif"));
		imagenesEstaticas.put(""+Estacion.CA2_BORRA_DATOS, cargador.getImagen("borrarCA2Fija.gif"));
		imagenesEstaticas.put(""+Estacion.CA1_SOLICITA_ENVIO_DE_PETICION, cargador.getImagen("CA1SolicitaEnvioDePeticionFija.gif"));
		imagenesEstaticas.put(""+Estacion.CA2_SOLICITA_ENVIO_DE_PETICION, cargador.getImagen("CA2SolicitaEnvioDePeticionFija.gif"));
		imagenesEstaticas.put(""+Estacion.CA1_ENVIA_RC, cargador.getImagen("CA1enviaRCFija.gif"));
		imagenesEstaticas.put(""+Estacion.CA2_ENVIA_RC, cargador.getImagen("CA2enviaRCFija.gif"));
		
		//Cargamos los nombres de los archivos de audio asociados a los eventos que nos interesan (sern solicitados por BloqueAudio)
		sonidos.put(""+Estacion.USUARIO_GENERA_DATOS_CA1, directorioAudio+"usuarioGeneraCA1.mp3");
		sonidos.put(""+Estacion.USUARIO_GENERA_DATOS_CA2, directorioAudio+"usuarioGeneraCA2.mp3");
		sonidos.put(""+Estacion.USUARIO_NO_GENERA_DATOS, directorioAudio+"usuarioNoGenera.mp3");
		sonidos.put(""+Estacion.CA1_ACEPTA_DATOS, directorioAudio+"CA1DatosAceptados.mp3");
		sonidos.put(""+Estacion.CA2_ACEPTA_DATOS, directorioAudio+"CA2DatosAceptados.mp3");
		sonidos.put(""+Estacion.CA1_MARCA_TX_PENDIENTE,directorioAudio+"CA1TxPendiente.mp3");
		sonidos.put(""+Estacion.CA2_MARCA_TX_PENDIENTE, directorioAudio+"CA2TxPendiente.mp3");
		sonidos.put(""+Estacion.CA1_RECHAZA_DATOS, directorioAudio+"CA1DatosRechazados.mp3");
		sonidos.put(""+Estacion.CA2_RECHAZA_DATOS, directorioAudio+"CA2DatosRechazados.mp3");
		sonidos.put(""+Estacion.CA1_RECIBIDA_CELDA_VACIA, directorioAudio+"CA1celdaRecibida.mp3");
		sonidos.put(""+Estacion.CA2_RECIBIDA_CELDA_VACIA, directorioAudio+"CA2celdaRecibida.mp3");
		sonidos.put(""+Estacion.CA1_RECIBIDA_CELDA_OCUPADA, directorioAudio+"CA1celdaRecibida.mp3");
		sonidos.put(""+Estacion.CA2_RECIBIDA_CELDA_OCUPADA, directorioAudio+"CA2celdaRecibida.mp3");
		sonidos.put(""+Estacion.CA1_ENVIA_DATOS_A_USUARIO, directorioAudio+"CA1aUsuario.mp3");
		sonidos.put(""+Estacion.CA2_ENVIA_DATOS_A_USUARIO, directorioAudio+"CA2aUsuario.mp3");
		sonidos.put(""+Estacion.CA1_CELDA_NO_RECIBIDA, directorioAudio+"CA1CeldaNoRecibida.mp3");
		sonidos.put(""+Estacion.CA2_CELDA_NO_RECIBIDA, directorioAudio+"CA2CeldaNoRecibida.mp3");
		sonidos.put(""+Estacion.CA1_Y_CA2_NO_RECIBEN_CELDA, directorioAudio+"CA1CA2noreciben.mp3");
		sonidos.put(""+Estacion.CA1_NORECIBE_CA2_RECIBE_ENVIA, directorioAudio+"CA1norecibeCA2recibeYenvia.mp3");
		sonidos.put(""+Estacion.CA1_NORECIBE_CA2_RECIBE_NOENVIA, directorioAudio+"CA1norecibeCA2recibeYnoenvia.mp3");
		sonidos.put(""+Estacion.CA1_RECIBE_ENVIA_CA2_NO_RECIBE, directorioAudio+"CA1recibeYenviaCA2norecibe.mp3");
		sonidos.put(""+Estacion.CA1_RECIBE_NOENVIA_CA2_NO_RECIBE, directorioAudio+"CA1recibeYnoenviaCA2norecibe.mp3");
		sonidos.put(""+Estacion.CA1_RECIBE_ENVIA_CA2_RECIBE_NOENVIA, directorioAudio+"CA1recibeYenviaCA2recibeYnoenvia.mp3");
		sonidos.put(""+Estacion.CA1_RECIBE_NOENVIA_CA2_RECIBE_ENVIA, directorioAudio+"CA1recibeYnoenviaCA2recibeYenvia.mp3");
		sonidos.put(""+Estacion.CA1_Y_CA2_RECIBEN_ENVIAN, directorioAudio+"CA1CA2recibenYenvian.mp3");
		sonidos.put(""+Estacion.CA1_Y_CA2_RECIBEN_NOENVIAN, directorioAudio+"CA1CA2recibenYnoenvian.mp3");
		sonidos.put(""+Estacion.CA1_CA2_A_USUARIO, directorioAudio+"CA1CA2aUsuario.mp3");	
		sonidos.put(""+Estacion.CA1_CA2_INSERTAN_DATOS, directorioAudio+"CA1CA2InsertanDatos.mp3");
		sonidos.put(""+Estacion.CA1_INSERTA_DATOS, directorioAudio+"CA1InsertaDatos.mp3");
		sonidos.put(""+Estacion.CA2_INSERTA_DATOS, directorioAudio+"CA2InsertaDatos.mp3");
		sonidos.put(""+Estacion.CA1_INSERTA_DATOS_V3V4, directorioAudio+"CA1InsertaDatosV3V4.mp3");
		sonidos.put(""+Estacion.CA2_INSERTA_DATOS_V3V4, directorioAudio+"CA2InsertaDatosV3V4.mp3");
		sonidos.put(""+Estacion.CA1_CA2_INSERTAN_DATOS_V3V4, directorioAudio+"CA1CA2InsertanDatosV3V4.mp3");
		sonidos.put(""+Estacion.CA1_NO_PUEDE_INSERTAR_DATOS, directorioAudio+"usuarioNoGenera.mp3");
		sonidos.put(""+Estacion.CA2_NO_PUEDE_INSERTAR_DATOS, directorioAudio+"usuarioNoGenera.mp3");		
		sonidos.put(""+Estacion.CA1_CA2_BORRAN_DATOS, directorioAudio+"borrarCA1yCA2.mp3");
		sonidos.put(""+Estacion.CA1_BORRA_DATOS, directorioAudio+"borrarCA1.mp3");
		sonidos.put(""+Estacion.CA2_BORRA_DATOS, directorioAudio+"borrarCA2.mp3");
		sonidos.put(""+Estacion.CA1_NO_DESTINATARIO, directorioAudio+"usuarioNoDestinatario.mp3");
		sonidos.put(""+Estacion.CA2_NO_DESTINATARIO, directorioAudio+"usuarioNoDestinatario.mp3");
		sonidos.put(""+Estacion.CA1_SOLICITA_ENVIO_DE_PETICION, directorioAudio+"CA1SolicitaEnvioDePeticion.mp3");
		sonidos.put(""+Estacion.CA2_SOLICITA_ENVIO_DE_PETICION, directorioAudio+"CA2SolicitaEnvioDePeticion.mp3");
		sonidos.put(""+Estacion.CA1_ENVIA_RC, directorioAudio+"CA1enviaRC.mp3");
		sonidos.put(""+Estacion.CA2_ENVIA_RC, directorioAudio+"CA2enviaRC.mp3");
		sonidos.put(""+Estacion.CA1_ENVIA_PETICION, directorioAudio+"CA1PetOK.mp3");
		sonidos.put(""+Estacion.CA2_ENVIA_PETICION, directorioAudio+"CA2PetOK.mp3");
		sonidos.put(""+Estacion.CA1_CA2_ENVIAN_PETICION, directorioAudio+"CA1CA2PetOK.mp3");
	}
	
	//Devuelve una referencia al objeto nico de esta clase (segn el patrn Singleton)
	public static FactoriaMultimedia getFactoria()
	{
		if(factoria==null) factoria=new FactoriaMultimedia();
		return factoria;
	}
	
	//Devuelve la imagen animada asociada al evento indicado ('idEvento' lo genera cada estacin, y BloqueSimulacion lo enva a los observadores BloqueAudio y BloqueGrafico, segn el patrn Observador)
	public static Image getImagen(int idEvento)
	{
		return imagenes.get(""+idEvento);
	}
	
	//Devuelve la imagen fija asociada al evento indicado
	public static Image getImagenEstatica(int idEvento)
	{
		return imagenesEstaticas.get(""+idEvento);
	}
	
	//Devuelve el nombre del archivo de sonido asociado al evento indicado
	public static String getSonido(int idEvento)
	{
		return sonidos.get(""+idEvento);
	}
}


