import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//CLASE QUE EXTIENDE DE LA CLASE JPopupMenu E IMPLEMENTA LA VENTANA DE CONFIGURACIN DE SLOTS
public class PanelConfiguracionDeSlots extends JPopupMenu implements ActionListener
{
	private BotonSlot botonSlots;
	private JMenuItem itemSlots;
	private JButton botonCambiar;
	private JLabel avisos;
	private TextFieldNumerico textFieldNumeroSlots;

	//CONSTRUCTOR: Se le pasa como parmetro de entrada el BotonSlot (encargado invocar la simulacin de slots) para que al configurar el nmero de slots el objeto de esta clase pueda pasarle el nmero de slots que debe simular.
	public PanelConfiguracionDeSlots(BotonSlot botonSlots, JMenuItem itemSlots)
	{
		super();
		this.botonSlots=botonSlots;
		this.itemSlots=itemSlots;
		
		setBorder(BorderFactory.createLineBorder(Color.black, 2));
		
		Boton botonCambiar=new Boton(CargadorDeImagenes.getCargador().getIcono("botonCambiar.gif"), CargadorDeImagenes.getCargador().getIcono("botonCambiarPressed.gif"));
		botonCambiar.addActionListener(this);
		
		PanelConFondo contenedor=new PanelConFondo("panelNumeroSlots.gif");
		setSize(contenedor.getPreferredSize());
		
		setOpaque(false);


		textFieldNumeroSlots=new TextFieldNumerico(1, 5);
		textFieldNumeroSlots.setHorizontalAlignment(SwingConstants.CENTER);
		textFieldNumeroSlots.setFont(new Font("Arial", Font.BOLD, 22));
		textFieldNumeroSlots.setText(""+botonSlots.getNumeroSlots());
		Dimension dim=new Dimension(90,32);
		textFieldNumeroSlots.setPreferredSize(dim);
		textFieldNumeroSlots.setMaximumSize(dim);
		textFieldNumeroSlots.setMinimumSize(dim);
	
		JPanel panelAuxiliar=new JPanel();
		panelAuxiliar.setLayout(new BoxLayout(panelAuxiliar, BoxLayout.X_AXIS));
		panelAuxiliar.setOpaque(false);
		panelAuxiliar.add(textFieldNumeroSlots);
		panelAuxiliar.add(Box.createRigidArea(new Dimension(10,0)));
		panelAuxiliar.add(botonCambiar);
		panelAuxiliar.setAlignmentX(0.5f);
		
		
		avisos=new JLabel("");
		avisos.setForeground(Color.red);
		avisos.setAlignmentX(0.5f);
		contenedor.setOpaque(false);
		contenedor.setLayout(new BoxLayout(contenedor, BoxLayout.Y_AXIS));
		contenedor.add(Box.createRigidArea(new Dimension(0,32)));
		contenedor.add(panelAuxiliar);
		contenedor.add(avisos);

		add(contenedor);
		pack();	

	}
	
	//Mtodo de la interfaz ActionListener: Se encarga de verificar si el nmero de slots es vlido
	public void actionPerformed(ActionEvent ev)							  
	{
		String stringSlots=textFieldNumeroSlots.getText();
		if(stringSlots.compareTo("")!=0) 
		{
			try
			{
				int slots=Integer.parseInt(stringSlots); 
				
				botonSlots.setNumeroSlots(slots);
				if (slots<1) //No permite especificar 0 slots
				{
					avisos.setText("Nmero de slots invlido");
					return;
				}
				else if(slots==1) itemSlots.setText("Slot");
				else itemSlots.setText(stringSlots+ " Slots");
				setVisible(false);
			}
			catch(NumberFormatException ex)
			{
				avisos.setText("Nmero de slots invlido");
			}
		}
	}
	
}

