import javax.swing.JTextField;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.*;
import java.util.*;

//CLASE QUE EXTIENDE DE JTextField PARA IMPLEMENTAR CAMPOS DE TEXTO QUE SLO PERMITEN LA INSERCIN DE UN TIPO DE DATOS CONCRETO ("nmeros enteros positivos" o "doubles")
public class TextFieldNumerico extends JTextField implements KeyListener
{
	private int pos; //Almacenar la posicin del caret en el textfield para procesar la informacin que introducimos por teclado y actuar en consecuencia: Por ejeplo: en la posin caret=1 siempre debe ir una coma cuando tenemos qe introducir un valor de probabilidad, as pues en la posicin 1 nunca permitiremos escribir otro caracter distinto de la coma
	private int tipo; 
	//La variable tipo indica el tipo de datos que debe contener:
	//tipo=1 --> DGITOS DE 0 a 9,   
	//tipo=2 --> PROBABILIDAD, nmeros comprendidos en el intervalo [0.0; 1.0];
	
	private char caracterTecleado;
	private boolean estaEscritoElPunto;
	private boolean sePuedeEscribirMas;
	
	//CONSTRUCTOR 1
	public TextFieldNumerico(int tipo)
	{
		super();
		addKeyListener(this);
		estaEscritoElPunto=false;
		sePuedeEscribirMas=true;
		this.tipo=tipo;
	}
	
	//CONSTRUCTOR 2
	public TextFieldNumerico(int tipo, int numeroColumnas)
	{
		super(numeroColumnas);
		addKeyListener(this);
		estaEscritoElPunto=false;
		sePuedeEscribirMas=true;
		this.tipo=tipo;	
	}
	
	//CONSTRUCTOR 2
	public TextFieldNumerico(int tipo, String valor, int numeroColumnas)
	{
		super(valor, numeroColumnas);
		addKeyListener(this);
		estaEscritoElPunto=false;
		sePuedeEscribirMas=true;
		this.tipo=tipo;
	}
	
	//Sobreescribe el mtodo paintComponent dela clase JTextField para que suavice el texto que contiene
	public void paintComponent(Graphics g)
	{
		if (g instanceof Graphics2D)
		{
      		Graphics2D g2 = (Graphics2D)g;
      		Map<Object, Object> rMap = new HashMap<Object, Object>();
        	Object key = RenderingHints.KEY_ANTIALIASING;
        	Object value = RenderingHints.VALUE_ANTIALIAS_ON;
        	rMap.put(key, value);
        	g2.addRenderingHints(rMap);
    	}
    	super.paintComponent(g);
	}
	
	//Mtodos de la interfaz KeyListener
	public void keyTyped (KeyEvent e) 
    { 
		pos=getCaretPosition();

		if (tipo==1) //Para el caso en que solo es vlido escribir nmeros no negativos
		{
			caracterTecleado = e.getKeyChar();
           	if (!((caracterTecleado==KeyEvent.VK_DELETE) || (caracterTecleado==KeyEvent.VK_BACK_SPACE) ||  (caracterTecleado== KeyEvent.VK_ENTER)      || (caracterTecleado == KeyEvent.VK_TAB) ||  (Character.isDigit(caracterTecleado)))) 
       		e.consume() ;
			
		}
			
		else if (tipo==2) //Para el caso en que solo es vlido escribir una probabilidad - Nmeros comprendidos entre 0.0 y 1.0
		{
			caracterTecleado = e.getKeyChar();

			if (caracterTecleado== KeyEvent.VK_PERIOD) 
			{
				int posicion=0;
				String aux=getText();
				estaEscritoElPunto=false;
				while (posicion<aux.length())
				{
					if(aux.charAt(posicion)==KeyEvent.VK_PERIOD) estaEscritoElPunto=true;
					posicion++;
				}

				if(estaEscritoElPunto==true) e.consume();
			}
			
	
           	else if (!((Character.isDigit(caracterTecleado)) || (caracterTecleado== KeyEvent.VK_BACK_SPACE) ||  (caracterTecleado== KeyEvent.VK_ENTER) || (caracterTecleado== KeyEvent.VK_DELETE) || (caracterTecleado == KeyEvent.VK_TAB)))
           		e.consume() ;
		
		}	      
    } 

	public void keyPressed (KeyEvent e) {}
	public void keyReleased (KeyEvent e) {}
} 