import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.lang.Thread;
import javax.swing.event.*;
import java.awt.font.*;

//CLASE QUE IMPLEMENTA EL BLOQUE DE ESTADSTICAS, ENCARGADO DE GENERAR LAS GRFICAS Y PERMITIR LA NAVEGACIN POR LAS MISMAS
public class BloqueEstadisticas extends JPanel implements MouseListener, MouseMotionListener, ChangeListener, Runnable
{
	private boolean cancelarSimulacion;
	private String avisos;
	private JPanel panelGraficasSeleccionado;
	private JTabbedPane contenedorEstadisticas, contenedorBuses1, contenedorBuses2, contenedorBuses3;
	private JPanel panelDatos;
	private JScrollPane scrollerTcGlobal, scrollerTcBus1, scrollerTcBus2, scrollerTsBus1, scrollerTsBus2, scrollerTcTsBus1, scrollerTcTsBus2;
	private JPanel panelGraficasTcGlobal, panelGraficasTcBus1, panelGraficasTcBus2, panelGraficasTsBus1, panelGraficasTsBus2, panelGraficasTcVsTsBus1, panelGraficasTcVsTsBus2;

	private boolean procesando;
	private Vector<Grafica> graficasTcBus1, graficasTcBus2, graficasTsBus1, graficasTsBus2,graficasTcTsBus1, graficasTcTsBus2;
	private Image menuSimulacion, imagenCalculando;
	private TextFieldNumerico textfieldSlots, textfieldEstaciones;
	private Boton botonVersion1, botonVersion2, botonVersion3, botonVersion4, botonSimular;
	private Boton botonInicio, botonRetroceder, botonAvanzar, botonFin;
	private JLabel labelNavegador;
	private JSlider barra;
	private ImageIcon iconoVersion1, iconoVersion2, iconoVersion3, iconoVersion4;
	private int slots, estaciones, version, progreso; 
	private Estacion[] arrayEstaciones;
	private Grafica graficaMaximizada;
	private Grafica grafSistema, grafBus1, grafBus2;
	private GraficaMultiple graficaMultipleTcBus1, graficaMultipleTcBus2, graficaMultipleTsBus1, graficaMultipleTsBus2, graficaMultipleTsTcBus1, graficaMultipleTsTcBus2;
	private CargadorDeImagenes cargador;
	
	//Array con las PG a emplear para la generacin de las grficas
	private final double[] pg={ 0.01, 0.02, 0.03, 0.04, 0.05, 0.06, 0.07, 0.08,
							  0.09, 0.10, 0.11, 0.12, 0.13, 0.14, 0.15, 0.16,
							  0.17, 0.18, 0.19, 0.20, 0.21, 0.22, 0.23, 0.24,
							  0.25, 0.26, 0.27, 0.28, 0.29, 0.30, 0.31, 0.32,
							  0.33, 0.34, 0.35, 0.36, 0.37, 0.38, 0.39, 0.40,
							  0.41, 0.42, 0.43, 0.44, 0.45, 0.46, 0.47, 0.48,
							  0.49, 0.50, 0.51, 0.52, 0.53, 0.54, 0.55, 0.56,
							  0.57, 0.58, 0.59, 0.60, 0.61, 0.62, 0.63, 0.64,
							  0.65, 0.66, 0.67, 0.68, 0.69, 0.70, 0.71, 0.72,
							  0.73, 0.74, 0.75, 0.76, 0.77, 0.78, 0.79, 0.80,
							  0.81, 0.82, 0.83, 0.84, 0.85, 0.86, 0.87, 0.88,
							  0.89, 0.90, 0.91, 0.92, 0.93, 0.94, 0.95, 0.96,
							  0.97, 0.98, 0.99, 1.0 };
	
	//CONSTRUCTOR (CONSTRUYE LA INTERFAZ GRFICA DEL BLOQUE)
	public BloqueEstadisticas(int estaciones, int version)
	{
		super();
		cargador=cargador.getCargador();
		graficasTcBus1=new Vector<Grafica>();
		graficasTcBus2=new Vector<Grafica>();
		graficasTsBus1=new Vector<Grafica>();
		graficasTsBus2=new Vector<Grafica>();
		graficasTcTsBus1=new Vector<Grafica>();
		graficasTcTsBus2=new Vector<Grafica>();
		slots=Constantes.SLOTS_SIMULACION;
		this.estaciones=estaciones;
		this.version=version;

		menuSimulacion=cargador.getImagen("panelEstadisticas.gif");
		imagenCalculando=cargador.getImagen("labelCalculando.gif");
		
		textfieldSlots=new TextFieldNumerico(1,5);
		textfieldEstaciones=new TextFieldNumerico(1,5);
		textfieldSlots.setHorizontalAlignment(SwingConstants.CENTER);
		textfieldEstaciones.setHorizontalAlignment(SwingConstants.CENTER);
		
		Font font=new Font("Arial", Font.BOLD, 17);
		textfieldSlots.setFont(font);
		textfieldEstaciones.setFont(font);
		
		textfieldSlots.setText(""+Constantes.SLOTS_SIMULACION);
		textfieldEstaciones.setText(""+estaciones);
		botonVersion1=new Boton((iconoVersion1=cargador.getIcono("botonVersion1.gif")), cargador.getIcono("botonVersion1Selected.gif"), this);
		botonVersion2=new Boton((iconoVersion2=cargador.getIcono("botonVersion2.gif")), cargador.getIcono("botonVersion2Selected.gif"), this);
		botonVersion3=new Boton((iconoVersion3=cargador.getIcono("botonVersion3.gif")), cargador.getIcono("botonVersion3Selected.gif"), this);
		botonVersion4=new Boton((iconoVersion4=cargador.getIcono("botonVersion4.gif")), cargador.getIcono("botonVersion4Selected.gif"), this);
		botonSimular=new Boton(cargador.getIcono("botonComenzarSimulacion.gif"), cargador.getIcono("botonComenzarSimulacionPressed.gif"), this);
		
		if(version==1) botonVersion1.setIcon(botonVersion1.getPressedIcon());
		else if(version==2) botonVersion2.setIcon(botonVersion2.getPressedIcon());
		else if(version==3) botonVersion3.setIcon(botonVersion3.getPressedIcon());
		else if(version==4) botonVersion4.setIcon(botonVersion4.getPressedIcon());
		
		labelNavegador=new JLabel(cargador.getIcono("labelNavegador.gif"));
		labelNavegador.setVisible(false);
		barra=new JSlider(JSlider.HORIZONTAL, 0, 1, 1);
		barra.addChangeListener(this);
		barra.setOpaque(false);
		barra.setPreferredSize(new Dimension(180,16));
		barra.setMaximumSize(new Dimension(180,16));
		barra.setMinimumSize(new Dimension(180,16));
		barra.setVisible(false);
		
		textfieldSlots.setAlignmentX(0.5f);
		textfieldEstaciones.setAlignmentX(0.5f);
		botonVersion1.setAlignmentX(0.5f);
		botonVersion2.setAlignmentX(0.5f);
		botonVersion3.setAlignmentX(0.5f);
		botonVersion4.setAlignmentX(0.5f);
		botonSimular.setAlignmentX(0.5f);
		labelNavegador.setAlignmentX(0.5f);
		barra.setAlignmentX(0.5f);
		
		botonVersion1.setBorderPainted(false);
		botonVersion2.setBorderPainted(false);
		botonVersion3.setBorderPainted(false);
		botonVersion4.setBorderPainted(false);
		
	
		botonInicio=new Boton(cargador.getIcono("botonInicio.gif"), cargador.getIcono("botonInicioPressed.gif"), this);
		botonRetroceder=new Boton(cargador.getIcono("botonRetroceder.gif"), cargador.getIcono("botonRetrocederPressed.gif"), this);
		botonAvanzar=new Boton(cargador.getIcono("botonAvanzar.gif"), cargador.getIcono("botonAvanzarPressed.gif"), this);
		botonFin=new Boton(cargador.getIcono("botonFin.gif"), cargador.getIcono("botonFinPressed.gif"), this);
		
		 
		botonInicio.setVisible(false);
		botonRetroceder.setVisible(false);
		botonAvanzar.setVisible(false);
		botonFin.setVisible(false);
		
		JPanel panelExploracion= new JPanel();
		panelExploracion.setOpaque(false);
		panelExploracion.setLayout(new BoxLayout(panelExploracion, BoxLayout.X_AXIS));
		panelExploracion.add(botonInicio);
		panelExploracion.add(Box.createRigidArea(new Dimension(1,0)));
		panelExploracion.add(botonRetroceder);
		panelExploracion.add(Box.createRigidArea(new Dimension(1,0)));
		panelExploracion.add(botonAvanzar);
		panelExploracion.add(Box.createRigidArea(new Dimension(1,0)));
		panelExploracion.add(botonFin);
		panelExploracion.setAlignmentX(0.5f);
		
		
		JPanel panelMenuEstadisticas=new JPanel();
		panelMenuEstadisticas.setAlignmentY(0f);
		panelMenuEstadisticas.setLayout(new BoxLayout(panelMenuEstadisticas, BoxLayout.Y_AXIS));
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,83)));
		panelMenuEstadisticas.add(textfieldSlots);
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,44)));
		panelMenuEstadisticas.add(textfieldEstaciones);
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,46)));
		panelMenuEstadisticas.add(botonVersion1);
		panelMenuEstadisticas.add(botonVersion2);
		panelMenuEstadisticas.add(botonVersion3);
		panelMenuEstadisticas.add(botonVersion4);
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,46)));
		panelMenuEstadisticas.add(botonSimular);
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,20)));
		panelMenuEstadisticas.add(labelNavegador);
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,8)));
		panelMenuEstadisticas.add(panelExploracion);
		panelMenuEstadisticas.add(Box.createRigidArea(new Dimension(0,5)));
		panelMenuEstadisticas.add(barra);
		panelMenuEstadisticas.setOpaque(false);
		Dimension dim=new Dimension(menuSimulacion.getWidth(this),menuSimulacion.getHeight(this));
		panelMenuEstadisticas.setPreferredSize(dim);
		panelMenuEstadisticas.setMaximumSize(dim);
		panelMenuEstadisticas.setMinimumSize(dim);
		
		dim=new Dimension(50,25);
		textfieldSlots.setPreferredSize(dim);
		textfieldSlots.setMaximumSize(dim);
		textfieldSlots.setMinimumSize(dim);
		dim=new Dimension(80,25);
		textfieldEstaciones.setPreferredSize(dim);
		textfieldEstaciones.setMaximumSize(dim);
		textfieldEstaciones.setMinimumSize(dim);
		
		
		
		contenedorEstadisticas=new JTabbedPane();
		contenedorEstadisticas.setAlignmentY(0f);
		contenedorBuses1=new JTabbedPane();
		contenedorBuses2=new JTabbedPane();
		contenedorBuses3=new JTabbedPane();
		
		contenedorEstadisticas.addChangeListener(this);
		contenedorBuses1.addChangeListener(this);
		contenedorBuses2.addChangeListener(this);
		contenedorBuses3.addChangeListener(this);
		
		panelDatos=new JPanel();
		
		
		
		
		//Paneles TC
		panelGraficasTcGlobal=new JPanel();
		panelGraficasTcBus1=new JPanel();
		panelGraficasTcBus2=new JPanel();
		panelGraficasTcGlobal.setLayout(new BoxLayout(panelGraficasTcGlobal, BoxLayout.Y_AXIS));
		panelGraficasTcBus1.setLayout(new BoxLayout(panelGraficasTcBus1, BoxLayout.Y_AXIS));
		panelGraficasTcBus2.setLayout(new BoxLayout(panelGraficasTcBus2, BoxLayout.Y_AXIS));
		
		panelGraficasSeleccionado=panelGraficasTcGlobal;
		
		//Paneles TS
		panelGraficasTsBus1=new JPanel();
		panelGraficasTsBus2=new JPanel();
		panelGraficasTsBus1.setLayout(new BoxLayout(panelGraficasTsBus1, BoxLayout.Y_AXIS));
		panelGraficasTsBus2.setLayout(new BoxLayout(panelGraficasTsBus2, BoxLayout.Y_AXIS));
				
		//Paneles TC vs TS
		panelGraficasTcVsTsBus1=new JPanel();
		panelGraficasTcVsTsBus2=new JPanel();
		panelGraficasTcVsTsBus1.setLayout(new BoxLayout(panelGraficasTcVsTsBus1, BoxLayout.Y_AXIS));
		panelGraficasTcVsTsBus2.setLayout(new BoxLayout(panelGraficasTcVsTsBus2, BoxLayout.Y_AXIS));
			
		scrollerTcGlobal=new JScrollPane(panelGraficasTcGlobal);
		scrollerTcBus1=new JScrollPane(panelGraficasTcBus1);
		scrollerTcBus2=new JScrollPane(panelGraficasTcBus2);
		scrollerTsBus1=new JScrollPane(panelGraficasTsBus1);
		scrollerTsBus2=new JScrollPane(panelGraficasTsBus2);
		scrollerTcTsBus1=new JScrollPane(panelGraficasTcVsTsBus1);
		scrollerTcTsBus2=new JScrollPane(panelGraficasTcVsTsBus2);
		
			
		contenedorBuses1.addTab("", cargador.getIcono("global.gif"), scrollerTcGlobal, null); 
		contenedorBuses1.addTab("", cargador.getIcono("bus1.gif"), scrollerTcBus1, null);
		contenedorBuses1.addTab("", cargador.getIcono("bus2.gif"), scrollerTcBus2, null); 
		

		contenedorBuses2.addTab("", cargador.getIcono("bus1.gif"), scrollerTsBus1, null);
		contenedorBuses2.addTab("", cargador.getIcono("bus2.gif"), scrollerTsBus2, null); 
		
		contenedorBuses3.addTab("", cargador.getIcono("bus1.gif"), scrollerTcTsBus1, null); 
		contenedorBuses3.addTab("", cargador.getIcono("bus2.gif"), scrollerTcTsBus2, null); 
			
		contenedorEstadisticas.addTab("", cargador.getIcono("tc.gif"), contenedorBuses1, null); 
		contenedorEstadisticas.addTab("", cargador.getIcono("ts.gif"), contenedorBuses2, null);
		contenedorEstadisticas.addTab("", cargador.getIcono("tcts.gif"), contenedorBuses3, null);
		contenedorEstadisticas.addTab("", cargador.getIcono("zoom.gif"), new JScrollPane(panelDatos), "ltimo zoom realizado");
		
		
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		add(panelMenuEstadisticas);
		add(contenedorEstadisticas);
		setBackground(new Color(238, 238, 238));
		
	}
	
	//Sobreescribe el mtodo paintComponent  para que pinte el indicador de proceso (porcentaje completado durante la generacin de las grficas) y los avisos pertinentes
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		g.drawImage(menuSimulacion,0,0,this);
		Graphics2D graphics2d = (Graphics2D)g;
		graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		//Pinta el porcentaje de proceso completado	
		if (procesando)
		{
			graphics2d.drawImage(imagenCalculando,33,380,this);
			
			if (cancelarSimulacion) 
			{
				graphics2d.setColor(Color.red);
				graphics2d.setFont(new Font("Arial", Font.BOLD, 14));
				graphics2d.drawString("CANCELANDO...", 50, 465);
			}
			
			graphics2d.setColor(Color.black);
			graphics2d.setFont(new Font("Arial", Font.BOLD, 25));
			graphics2d.drawString(""+progreso+" %", 80, 450);									
		}
		
		//Pinta avisos
		if (avisos!=null) 
		{
			Font fuente=new Font("Arial", Font.BOLD, 12);
			graphics2d.setFont(fuente);
			FontRenderContext frc = graphics2d.getFontRenderContext();
			LineMetrics linemetrics = fuente.getLineMetrics(avisos, frc);
			int largo = (int)fuente.getStringBounds(avisos, frc).getWidth();
		
			graphics2d.setColor(Color.red);
			graphics2d.drawString(avisos, (menuSimulacion.getWidth(this)-largo)/2,375);
			
		}
		
	}
	
	//Mtodos de la interfaz MouseListener
	public void mousePressed(MouseEvent ev)
	{
		Object implicado=ev.getSource();
		
		//Si se ha pulsado sibre una grfica que permite hacer zoom
		if (implicado instanceof Grafica)
		{
			Grafica grafica=(Grafica) ev.getSource();
			if (!grafica.esZoom())
			{
				//Borramos el zoom de la grafica previa, si hay alguna grafica maximizada.
				if (graficaMaximizada!=null)
					graficaMaximizada.eliminarZoom();
				
				//Creamos la nueva grfica zoom y la colocamos en la seccin ZOOM
				panelDatos.removeAll();
				graficaMaximizada=grafica;
				panelDatos.add(grafica.zoom());
				contenedorEstadisticas.setSelectedIndex(3);
			}
			return;
		}
		
		//Si se ha pulsado el botn simular
		else if (implicado==botonSimular)
		{
			//Si el bloque se encuentra generando grfica se cancela el proceso
			if (procesando) 
			{
				if(cancelarSimulacion) return;
				
				cancelarSimulacion=true;
				botonSimular.setEnabled(false);
				repaint();
				return;
			}
			
			//En caso contrario se comprueba si los parmetros especificados por el usuario son vlidos, y en caso afirmativo comienza el proceso de generacin de grficas
			try
			{	
				slots=Integer.parseInt(textfieldSlots.getText());
				if (slots<1)
				{
					avisos="Nmero de slots no es vlido";
					repaint();
					return;
				}
			} catch(NumberFormatException ex)
			{
				avisos="Nmero de slots no es vlido";
				repaint();
				return;
			}
					
			try
			{	
				estaciones=Integer.parseInt(textfieldEstaciones.getText());
				if (estaciones>Constantes.NUMERO_ESTACIONES_MAXIMO_ESTADISTICAS) 
				{
					avisos="Mximo estaciones = "+Constantes.NUMERO_ESTACIONES_MAXIMO_ESTADISTICAS;
					repaint();
					return;
				}
				
				else if (estaciones<2) 
				{
					avisos="Mnimo estaciones = 2";
					repaint();
					return;
				}
		
			} catch(NumberFormatException ex)
			{
				avisos="Mximo estaciones = "+Constantes.NUMERO_ESTACIONES_MAXIMO_ESTADISTICAS;
				repaint();
				return;
			}
			
		
		
			//Como vamos a iniciar una nueva simulacin, reseteamos el rango de la barra de navegacion:
			barra.setMaximum(1);
			barra.setValue(1);
			panelDatos.removeAll();
			setElementosActivados(false);
			contenedorEstadisticas.setSelectedIndex(0);
			Thread thr=new Thread(this);
			thr.setPriority(Thread.MIN_PRIORITY);
			thr.start();
			return;
		}
		
		

		
		//Si se ha pulsado la casilla versin 1 se deseleccionan las dems
		else if (implicado==botonVersion1)
		{
			version=1;
			botonVersion1.setIcon(botonVersion1.getPressedIcon());
			botonVersion2.setIcon(iconoVersion2);
			botonVersion3.setIcon(iconoVersion3);
			botonVersion4.setIcon(iconoVersion4);
		}
		
		//Si se ha pulsado la casilla versin 2 se deseleccionan las dems
		else if (implicado==botonVersion2)
		{
			version=2;
			botonVersion1.setIcon(iconoVersion1);
			botonVersion2.setIcon(botonVersion2.getPressedIcon());
			botonVersion3.setIcon(iconoVersion3);
			botonVersion4.setIcon(iconoVersion4);
		}
		
		//Si se ha pulsado la casilla versin 3 se deseleccionan las dems
		else if (implicado==botonVersion3)
		{
			version=3;
			botonVersion1.setIcon(iconoVersion1);
			botonVersion2.setIcon(iconoVersion2);
			botonVersion3.setIcon(botonVersion3.getPressedIcon());
			botonVersion4.setIcon(iconoVersion4);
		}
		
		//Si se ha pulsado la casilla versin 4 se deseleccionan las dems
		else if (implicado==botonVersion4)
		{
			version=4;
			botonVersion1.setIcon(iconoVersion1);
			botonVersion2.setIcon(iconoVersion2);
			botonVersion3.setIcon(iconoVersion3);
			botonVersion4.setIcon(botonVersion4.getPressedIcon());
		}
		
		//Si se ha pulsado el botn de navegacin "ir al inicio"
		else if (implicado==botonInicio)
		{
			barra.setValue(0);
			Component[] listaGraficas=panelGraficasSeleccionado.getComponents();
			for(int i=0; i<listaGraficas.length; i++) 
				if(listaGraficas[i] instanceof Grafica)
					((Grafica) listaGraficas[i]).setMarcadorDeNavegacion(0);			
		}
		
		//Si se ha pulsado el botn de navegacin "reroceder un punto"
		else if (implicado==botonRetroceder)
		{
			barra.setValue(barra.getValue()-1);
			Component[] listaGraficas=panelGraficasSeleccionado.getComponents();
			for(int i=0; i<listaGraficas.length; i++) 
				if(listaGraficas[i] instanceof Grafica)
					((Grafica) listaGraficas[i]).decrementarMarcadorDeNavegacion();			
		}
		
		//Si se ha pulsado el botn de navegacin "avanzar un punto"
		else if (implicado==botonAvanzar)
		{
			Component[] listaGraficas=panelGraficasSeleccionado.getComponents();
			barra.setValue(barra.getValue()+1);
			for(int i=0; i<listaGraficas.length; i++) 
				if(listaGraficas[i] instanceof Grafica)
					((Grafica) listaGraficas[i]).incrementarMarcadorDeNavegacion();	
					
		}
		
		//Si se ha pulsado el botn de navegacin "ir al final"
		else if (implicado==botonFin)
		{
			barra.setValue(barra.getMaximum());
			Component[] listaGraficas=panelGraficasSeleccionado.getComponents();
			for(int i=0; i<listaGraficas.length; i++) 
				if(listaGraficas[i] instanceof Grafica)
					((Grafica) listaGraficas[i]).setMarcadorDeNavegacion(barra.getMaximum());			
		}
	}
	
	public void mouseReleased(MouseEvent ev)
	{
	}
	
	public void mouseClicked(MouseEvent ev)
	{
	}
	
	public void mouseEntered(MouseEvent ev)
	{
		if (ev.getSource() instanceof Grafica)
		{
			Cursor cursor=cargador.getCursor("cursorHand.gif"); //CAMBIAR PUNTERO A CURSOR POR DEFECTO
			setCursor(cursor);
		}
	}
	
	public void mouseExited(MouseEvent ev)
	{
			if (ev.getSource() instanceof Grafica)
		{
			Grafica grafica=(Grafica) ev.getSource();
			grafica.setCoordenadasCursor(-1, -1);
			
			Cursor cursor=cargador.getCursor("cursorDefault.gif"); //CAMBIAR PUNTERO A CURSOR POR DEFECTO
			setCursor(cursor);
		}
	}
	
	//Mtodos de la interfaz MpuseMotionListener
	public void mouseMoved(MouseEvent ev)
	{
		if (ev.getSource() instanceof Grafica)
		{
			Grafica grafica=(Grafica) ev.getSource();
			grafica.setCoordenadasCursor(ev.getX(), ev.getY());
		}
	}
	
	public void mouseDragged(MouseEvent ev)
	{
	}
	
	//Mtodo de la interfaz ChangeListener
	public void stateChanged(ChangeEvent ev)
	{
		//Si es la barra actualizamos las graficas de la zona visible
		Object implicado=ev.getSource();
		
		if (implicado==barra)
		{
			if(procesando) return;
			Component[] listaGraficas=panelGraficasSeleccionado.getComponents();
			for(int i=0; i<listaGraficas.length; i++) 
				if(listaGraficas[i] instanceof Grafica)
					((Grafica) listaGraficas[i]).setMarcadorDeNavegacion(barra.getValue());
			return;
		}

		//Si no, seleccionamos la nueva zona visible
		JPanel subPanelVisibleAnterior=panelGraficasSeleccionado;
		Object subPanelVisible=contenedorEstadisticas.getSelectedComponent();
		if (subPanelVisible==contenedorBuses1) 
		{

			Component scrollerVisible=contenedorBuses1.getSelectedComponent();
			if(scrollerVisible==scrollerTcGlobal) panelGraficasSeleccionado=panelGraficasTcGlobal;
			if(scrollerVisible==scrollerTcBus1) panelGraficasSeleccionado=panelGraficasTcBus1;
			if(scrollerVisible==scrollerTcBus2) panelGraficasSeleccionado=panelGraficasTcBus2;
		}
		else if (subPanelVisible==contenedorBuses2)
		{
			Component scrollerVisible=contenedorBuses2.getSelectedComponent();
			if(scrollerVisible==scrollerTsBus1) panelGraficasSeleccionado=panelGraficasTsBus1;
			if(scrollerVisible==scrollerTsBus2) panelGraficasSeleccionado=panelGraficasTsBus2;
		}
		else if (subPanelVisible==contenedorBuses3)
		{
			Component scrollerVisible=contenedorBuses3.getSelectedComponent();
			if(scrollerVisible==scrollerTcTsBus1) panelGraficasSeleccionado=panelGraficasTcVsTsBus1;
			if(scrollerVisible==scrollerTcTsBus2) panelGraficasSeleccionado=panelGraficasTcVsTsBus2;
		}
		else
		{
			panelGraficasSeleccionado=panelDatos;
		}
		
		//Si se ha seleccionado un panelDistinto reseteamos la barra de navegacion y mostramos las graficas enteras, por si se haban dejado en un estado incompleto al cambiar de panel
		if (panelGraficasSeleccionado!=subPanelVisibleAnterior)
		{
			barra.setValue(barra.getMaximum());
			Component[] listaGraficas=panelGraficasSeleccionado.getComponents();
			for(int i=0; i<listaGraficas.length; i++) 
				if(listaGraficas[i] instanceof Grafica)
					((Grafica) listaGraficas[i]).setMarcadorDeNavegacion(barra.getMaximum());	
		}
	}
	
	
	
	//Mtodo que ejecutar el Thread encargado de generar las grficas
	public void run()
	{	
		procesando=true;
		
		crearGraficas();
		
		arrayEstaciones=new Estacion[estaciones];
		for(int i=0; i<arrayEstaciones.length; i++)
		{
			if(version==1) arrayEstaciones[i]=new EstacionVersion1(i+1, 0, estaciones, version);
			else if(version==2) arrayEstaciones[i]=new EstacionVersion2(i+1, 0, estaciones, version);
			else if(version==3) arrayEstaciones[i]=new EstacionVersion3(i+1, 0, estaciones, version);
			else if(version==4) arrayEstaciones[i]=new EstacionVersion4(i+1, 0, estaciones, version);
		}

		
		progreso=0;
		double p=0;
		int indice=0;	
		
		
		//Simulamos durante el nmero de slots especificado	(para cada versin, el orden de invocacin de los mtodos es el mismo empleado por BloqueSimulacin)	  
		for(int z=0; z<pg.length; z++)	
		{
			p=pg[z];
				progreso=(int) (p*100);
				repaint();
				
			//Reseteamos las estadisticas acumuladas por las estaciones e incrementamos la pg, para iniciar la nueva iteracin
			for(int i=0; i<estaciones; i++)
			{
				arrayEstaciones[i].resetear();
				arrayEstaciones[i].setPg(p);

			}		
			
			//EN CASO DE VERSIN 1
			if (version==1)
			{
				for(int j=1; j<=slots; j++)		
				{
					//Recepcion de celdas
					for(int i=0; i<estaciones; i++)
					{
						Celda celdaEntrada1=(i==0? new Celda(): arrayEstaciones[i-1].getCeldaSalida(1));
						Celda celdaEntrada2=(i==estaciones-1? new Celda(): arrayEstaciones[i+1].getCeldaSalida(2));
						
						if(i!=0) arrayEstaciones[i-1].setCeldaSalida(1, null);
						if(i!=arrayEstaciones.length-1) arrayEstaciones[i+1].setCeldaSalida(2, null);
						arrayEstaciones[i].setCeldaEntrada(1, celdaEntrada1);
						arrayEstaciones[i].setCeldaEntrada(2, celdaEntrada2);

				
					}
					
					//Resto de eventos
					for(int i=0; i<estaciones; i++)
					{
						arrayEstaciones[i].comprobarSiUsuarioGeneraDatos();
						arrayEstaciones[i].comprobarSiDatosSonAceptados();
							
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(1);
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(2);
						
					
						arrayEstaciones[i].comprobarDatosPendientesCA(1);
						arrayEstaciones[i].comprobarDatosPendientesCA(2);
					}
				}
			}
			
			//EN CASO DE VERSIN 2
			else if (version==2)
			{
				for(int j=1; j<=slots; j++)		
				{
					//Recepcion de celdas
					for(int i=0; i<estaciones; i++)
					{
						Celda celdaEntrada1=(i==0? new Celda(): arrayEstaciones[i-1].getCeldaSalida(1));
						Celda celdaEntrada2=(i==estaciones-1? new Celda(): arrayEstaciones[i+1].getCeldaSalida(2));
				
						if(i!=0) arrayEstaciones[i-1].setCeldaSalida(1, null);
						if(i!=arrayEstaciones.length-1) arrayEstaciones[i+1].setCeldaSalida(2, null);
						arrayEstaciones[i].setCeldaEntrada(1, celdaEntrada1);
						arrayEstaciones[i].setCeldaEntrada(2, celdaEntrada2);
				
					}
					
					//Resto de eventos
					for(int i=0; i<estaciones; i++)
					{
						arrayEstaciones[i].comprobarSiUsuarioGeneraDatos();
						arrayEstaciones[i].comprobarSiDatosSonAceptados();
						
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(1);
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(2);
		
						arrayEstaciones[i].borrarCelda(1);
						arrayEstaciones[i].borrarCelda(2);
						
						arrayEstaciones[i].comprobarDatosPendientesCA(1);
						arrayEstaciones[i].comprobarDatosPendientesCA(2);
					}
				}
			}
			
			//EN CASO DE VERSIN 3		
			else if (version==3)
			{
				for(int j=1; j<=slots; j++)		
				{	
		
					//Recepcion de celdas
					for(int i=0; i<estaciones; i++)
					{
						Celda celdaSalida1=arrayEstaciones[i].getCeldaSalida(1);
						Celda celdaSalida2=arrayEstaciones[i].getCeldaSalida(2);

						Celda celdaEntrada1=(i==0? new Celda(): arrayEstaciones[i-1].getCeldaSalida(1));
						Celda celdaEntrada2=(i==estaciones-1? new Celda(): arrayEstaciones[i+1].getCeldaSalida(2));
			
						boolean incrementaVacias1=false, incrementaVacias2=false;
				
						if(celdaEntrada1!=null && celdaEntrada1.getPeticion()) arrayEstaciones[i].incrementarContadorPeticiones(1);
						if(celdaEntrada2!=null && celdaEntrada2.getPeticion()) arrayEstaciones[i].incrementarContadorPeticiones(2);
						if(celdaSalida1!=null && !celdaSalida1.getOcupada()) incrementaVacias1=arrayEstaciones[i].contabilizarCeldaVacia(1);
						if(celdaSalida2!=null && !celdaSalida2.getOcupada()) incrementaVacias2=arrayEstaciones[i].contabilizarCeldaVacia(2);
					
						arrayEstaciones[i].setCeldaEntrada(1, celdaEntrada1);
						arrayEstaciones[i].setCeldaEntrada(2, celdaEntrada2);
					}
					
					//Resto de eventos
					for(int i=0; i<estaciones; i++)
					{			
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(1);
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(2);
						
						arrayEstaciones[i].comprobarSiUsuarioGeneraDatos();
						if (arrayEstaciones[i].comprobarSiUsuarioGeneraDatos()!=Estacion.USUARIO_NO_GENERA_DATOS)
						{

							arrayEstaciones[i].comprobarSiDatosSonAceptados();
						
					
							arrayEstaciones[i].comprobarSolicitudEnvioDePeticion(1);
							arrayEstaciones[i].comprobarSolicitudEnvioDePeticion(2);
							arrayEstaciones[i].comprobarEnvioRC(1);
							arrayEstaciones[i].comprobarEnvioRC(2);

						}
							arrayEstaciones[i].comprobarEnvioDePeticion(1);
							arrayEstaciones[i].comprobarEnvioDePeticion(2);
							arrayEstaciones[i].comprobarDatosPendientesCA(1);
							arrayEstaciones[i].comprobarDatosPendientesCA(2);
							
					}
				}
			}
			
			//EN CASO DE VERSIN 4
			else if (version==4)
			{
				
				for(int j=1; j<=slots; j++)		
				{
					//Recepcion de celdas
					for(int i=0; i<estaciones; i++)
					{
						Celda celdaSalida1=arrayEstaciones[i].getCeldaSalida(1);
						Celda celdaSalida2=arrayEstaciones[i].getCeldaSalida(2);

						Celda celdaEntrada1=(i==0? new Celda(): arrayEstaciones[i-1].getCeldaSalida(1));
						Celda celdaEntrada2=(i==estaciones-1? new Celda(): arrayEstaciones[i+1].getCeldaSalida(2));
			
						boolean incrementaVacias1=false, incrementaVacias2=false;
				
						if(celdaEntrada1!=null && celdaEntrada1.getPeticion()) arrayEstaciones[i].incrementarContadorPeticiones(1);
						if(celdaEntrada2!=null && celdaEntrada2.getPeticion()) arrayEstaciones[i].incrementarContadorPeticiones(2);
						if(celdaSalida1!=null && !celdaSalida1.getOcupada()) incrementaVacias1=arrayEstaciones[i].contabilizarCeldaVacia(1);
						if(celdaSalida2!=null && !celdaSalida2.getOcupada()) incrementaVacias2=arrayEstaciones[i].contabilizarCeldaVacia(2);
			
			
						arrayEstaciones[i].setCeldaEntrada(1, celdaEntrada1);
						arrayEstaciones[i].setCeldaEntrada(2, celdaEntrada2);
					}
					
					
					//Resto de eventos
					for(int i=0; i<estaciones; i++)
					{			
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(1);
						arrayEstaciones[i].comprobarSiCeldaContieneDatos(2);
												
							
						arrayEstaciones[i].borrarCelda(1);
						arrayEstaciones[i].borrarCelda(2);	
			
					
						if (arrayEstaciones[i].comprobarSiUsuarioGeneraDatos()!=Estacion.USUARIO_NO_GENERA_DATOS)
						{
							arrayEstaciones[i].comprobarSiDatosSonAceptados();
						
					
							arrayEstaciones[i].comprobarSolicitudEnvioDePeticion(1);
							arrayEstaciones[i].comprobarSolicitudEnvioDePeticion(2);
							arrayEstaciones[i].comprobarEnvioRC(1);
							arrayEstaciones[i].comprobarEnvioRC(2);
						}
							arrayEstaciones[i].comprobarEnvioDePeticion(1);
							arrayEstaciones[i].comprobarEnvioDePeticion(2);
	
							arrayEstaciones[i].comprobarDatosPendientesCA(1);
							arrayEstaciones[i].comprobarDatosPendientesCA(2);	
					}
				}
			}
					
					
			//TRAS SIMULAR TODOS LOS SLOTS PARA LA PG ACTUAL, SE RECOPILA LA INFORMACIN DE CADA ESTACIN, PARA CALCULAR E INSERTAR LOS DATOS EN LAS GRFICAS
			int sumaBus1=0, sumaBus2=0;
			for(int i=0; i<estaciones; i++)
			{
				sumaBus1=sumaBus1+arrayEstaciones[i].getTraficoCursado(1);
				sumaBus2=sumaBus2+arrayEstaciones[i].getTraficoCursado(2);
			}
						

			grafBus1.insertarPunto(p, (double)sumaBus1/(double)slots);
			grafBus2.insertarPunto(p, (double)sumaBus2/(double)slots);
			grafSistema.insertarPunto(p, ((double)sumaBus1+(double)sumaBus2)/(double)slots);
		
			int cursado=0, tiempoServicio=0;
			for(int i=0; i<estaciones; i++)
			{			
				if (i!=estaciones-1)
				{
					cursado=arrayEstaciones[i].getTraficoCursado(1);
					tiempoServicio=arrayEstaciones[i].getTiempoDeServicio(1);
				
					graficasTcBus1.elementAt(i).insertarPunto(p, (double) cursado/(double)slots);
					if(graficaMultipleTcBus1!=null) graficaMultipleTcBus1.insertarPunto(p, (double) cursado/(double)slots, i);
					
					if (cursado!=0)
					{
						graficasTsBus1.elementAt(i).insertarPunto(p, (double)tiempoServicio/(double)cursado);
						if(graficaMultipleTsBus1!=null)graficaMultipleTsBus1.insertarPunto(p, (double)tiempoServicio/(double)cursado, i);
						
						graficasTcTsBus1.elementAt(i).insertarPunto((double)cursado/(double)slots, (double)tiempoServicio/(double)cursado);
						if(graficaMultipleTsTcBus1!=null) graficaMultipleTsTcBus1.insertarPunto((double)cursado/(double)slots, (double)tiempoServicio/(double)cursado, i);
					
						
					}
					else
					{
						graficasTsBus1.elementAt(i).insertarPunto(p, (double)-1); //Infinito
						if(graficaMultipleTsBus1!=null)graficaMultipleTsBus1.insertarPunto(p, -1, i);
						
						graficasTcTsBus1.elementAt(i).insertarPunto((double)cursado/(double)slots, -1);
						if(graficaMultipleTsTcBus1!=null) graficaMultipleTsTcBus1.insertarPunto((double)cursado/(double)slots, -1, i);
					}
					
					
				
				}
				if (i!=0)
				{
					cursado=arrayEstaciones[i].getTraficoCursado(2);
					tiempoServicio=arrayEstaciones[i].getTiempoDeServicio(2);
					graficasTcBus2.elementAt(i-1).insertarPunto(p, (double)cursado/(double)slots);
					if(graficaMultipleTcBus2!=null) graficaMultipleTcBus2.insertarPunto(p, (double) cursado/(double)slots, i-1);
					
					if (cursado!=0)
					{
					
						graficasTsBus2.elementAt(i-1).insertarPunto(p, (double)tiempoServicio/(double)cursado);
						if(graficaMultipleTsBus2!=null)graficaMultipleTsBus2.insertarPunto(p, (double)tiempoServicio/(double)cursado, i-1);
						
						graficasTcTsBus2.elementAt(i-1).insertarPunto((double)cursado/(double)slots, (double)tiempoServicio/(double)cursado);
						if(graficaMultipleTsTcBus2!=null)graficaMultipleTsTcBus2.insertarPunto((double)cursado/(double)slots, (double)tiempoServicio/(double)cursado, i-1); //Si pongo i al pulsar en la grafica multiple mientras se genera la grafica no se actualiza bien, solo se ven los puntos que ya haban sido generados, se actualizan los mximos pero no aparecen los nuevos puntos.
					}
					
					else
					{
			
					
						graficasTsBus2.elementAt(i-1).insertarPunto(p, (double)-1);
						if(graficaMultipleTsBus2!=null)graficaMultipleTsBus2.insertarPunto(p, (double)-1, i-1);
						
						graficasTcTsBus2.elementAt(i-1).insertarPunto((double)cursado/(double)slots, -1);
						if(graficaMultipleTsTcBus2!=null)graficaMultipleTsTcBus2.insertarPunto((double)cursado/(double)slots, (double)-1, i-1); //Si pongo i al pulsar en la grafica multiple mientras se genera la grafica no se actualiza bien, solo se ven los puntos que ya haban sido generados, se actualizan los mximos pero no aparecen los nuevos puntos.
					}
				}	

			}

			barra.setMaximum(barra.getMaximum()+1);
			barra.setValue(barra.getMaximum()+1);
			if (cancelarSimulacion) 
			{
				procesando=false;
				cancelarSimulacion=false;
				setElementosActivados(true);
				botonSimular.setEnabled(true);
				progreso=0;
				repaint();
				return;
			}
			indice++;
	}
		
		
		//Finaliza elproceso de generacin, reactivndose los botones de configuracin
		procesando=false;	
		setElementosActivados(true);
	
	}
	
	//Mtodo que borra las grficas anteriores y crea las nuevas, para iniciar una nueva simulacin
	public void crearGraficas()
	{
		//Borramos las grficas anteriores
		graficasTcBus1.removeAllElements();
		graficasTcBus2.removeAllElements();
		graficasTsBus1.removeAllElements();
		graficasTsBus2.removeAllElements();
		graficasTcTsBus1.removeAllElements();
		graficasTcTsBus2.removeAllElements();
		
		panelGraficasTcGlobal.removeAll();
		panelGraficasTcBus1.removeAll();
		panelGraficasTcBus2.removeAll();
		panelGraficasTsBus1.removeAll();
		panelGraficasTsBus2.removeAll();
		panelGraficasTcVsTsBus1.removeAll();
		panelGraficasTcVsTsBus2.removeAll();
	
		Image backgroundGraficas=cargador.getImagen("backgroundGrafica.gif");	
		Image labelPgHorizontal=cargador.getImagen("pgHorizontal.gif");	
		Image labelTcHorizontal=cargador.getImagen("tcHorizontal.gif");
		Image labelTcVertical=cargador.getImagen("tcVertical.gif");		
		Image labelTsVertical=cargador.getImagen("tsVertical.gif");	
		Image labelTsHorizontal=cargador.getImagen("tsHorizontal.gif");
		Image tituloTcSistema=cargador.getImagen("tcSistema.gif");
		Image tituloTcEstacion=cargador.getImagen("tcEstacion.gif");
		Image tituloTsEstacion=cargador.getImagen("tsEstacion.gif");
		Image tituloTcBus1=cargador.getImagen("tcBus1.gif");
		Image tituloTcBus2=cargador.getImagen("tcBus2.gif");
		Image tituloTcTsEstacion=cargador.getImagen("tcTsEstacion.gif");
		Image tituloTcComparativa=cargador.getImagen("tcComparativa.gif");
		Image tituloTsComparativa=cargador.getImagen("tsComparativa.gif");
		Image tituloTcTsComparativa=cargador.getImagen("tctsComparativa.gif");

		grafSistema=new Grafica(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcSistema, -1, this);
		grafBus1=new Grafica(backgroundGraficas, labelPgHorizontal,labelTcVertical, tituloTcBus1, -1, this);
		grafBus2=new Grafica(backgroundGraficas, labelPgHorizontal,labelTcVertical, tituloTcBus2, -1, this);
		

		panelGraficasTcGlobal.add(grafSistema);
		panelGraficasTcBus1.add(grafBus1);
		panelGraficasTcBus2.add(grafBus2);
		
			
		for(int i=0; i<estaciones; i++)
		{
			if (i!=estaciones-1)
			{
				graficasTcBus1.add(new Grafica(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcEstacion, i+1, this));
				graficasTsBus1.add(new Grafica(backgroundGraficas, labelPgHorizontal, labelTsVertical, tituloTsEstacion, i+1, this));
				graficasTcTsBus1.add(new Grafica(backgroundGraficas, labelTcHorizontal,  labelTsVertical, tituloTcTsEstacion, i+1, this));
			
				panelGraficasTcBus1.add(graficasTcBus1.elementAt(i));
				panelGraficasTsBus1.add(graficasTsBus1.elementAt(i));
				panelGraficasTcVsTsBus1.add(graficasTcTsBus1.elementAt(i));
			}
			if (i!=0)
			{
				graficasTcBus2.add(new Grafica(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcEstacion, i+1, this));
				graficasTsBus2.add(new Grafica(backgroundGraficas, labelPgHorizontal, labelTsVertical, tituloTsEstacion, i+1, this));
				graficasTcTsBus2.add(new Grafica(backgroundGraficas, labelTcHorizontal,  labelTsVertical, tituloTcTsEstacion, i+1, this));
				
				panelGraficasTcBus2.add(graficasTcBus2.elementAt(i-1));
				panelGraficasTsBus2.add(graficasTsBus2.elementAt(i-1));
				panelGraficasTcVsTsBus2.add(graficasTcTsBus2.elementAt(i-1));
			}
		}
		
		if (estaciones<11) //Grficas mltiples soportan un mximo de 11 estaciones
		{
			graficaMultipleTcBus1=new GraficaMultiple(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcComparativa, -1, this, estaciones-1, 1);	
			graficaMultipleTcBus2=new GraficaMultiple(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcComparativa, -1, this, estaciones-1, 2);
			graficaMultipleTsBus1=new GraficaMultiple(backgroundGraficas, labelPgHorizontal, labelTsVertical, tituloTsComparativa, -1, this, estaciones-1, 1);	
			graficaMultipleTsBus2=new GraficaMultiple(backgroundGraficas, labelPgHorizontal, labelTsVertical, tituloTsComparativa, -1, this, estaciones-1, 2);	
			graficaMultipleTsTcBus1=new GraficaMultiple(backgroundGraficas, labelTcHorizontal,  labelTsVertical, tituloTcTsComparativa, -1, this, estaciones-1, 1);
			graficaMultipleTsTcBus2=new GraficaMultiple(backgroundGraficas, labelTcHorizontal,  labelTsVertical, tituloTcTsComparativa, -1, this, estaciones-1, 2);
	
			panelGraficasTcBus1.add(graficaMultipleTcBus1);
			panelGraficasTcBus2.add(graficaMultipleTcBus2);
			panelGraficasTsBus1.add(graficaMultipleTsBus1);
			panelGraficasTsBus2.add(graficaMultipleTsBus2);
			panelGraficasTcVsTsBus1.add(graficaMultipleTsTcBus1);
			panelGraficasTcVsTsBus2.add(graficaMultipleTsTcBus2);
		}
		
		else
		{
			graficaMultipleTcBus1=null;
			graficaMultipleTcBus2=null;
			graficaMultipleTsBus1=null;
			graficaMultipleTsBus2=null;
			graficaMultipleTsTcBus1=null;
			graficaMultipleTsTcBus2=null;
			panelGraficasTcBus1.add(new GraficaMultipleFantasma(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcComparativa));
			panelGraficasTcBus2.add(new GraficaMultipleFantasma(backgroundGraficas, labelPgHorizontal, labelTcVertical, tituloTcComparativa));
			panelGraficasTsBus1.add(new GraficaMultipleFantasma(backgroundGraficas, labelPgHorizontal, labelTsVertical, tituloTcComparativa));
			panelGraficasTsBus2.add(new GraficaMultipleFantasma(backgroundGraficas, labelPgHorizontal, labelTsVertical, tituloTcComparativa));
			panelGraficasTcVsTsBus1.add(new GraficaMultipleFantasma(backgroundGraficas, labelTsHorizontal, labelTcVertical, tituloTcComparativa));
			panelGraficasTcVsTsBus2.add(new GraficaMultipleFantasma(backgroundGraficas, labelTsHorizontal, labelTcVertical, tituloTcComparativa));
		}
	}
	
	//Activa/Descactiva los elementos de configuracin
	public void setElementosActivados(boolean b)
	{
			textfieldSlots.setEditable(b);
			textfieldEstaciones.setEditable(b);
			botonVersion1.setEnabled(b);
			botonVersion2.setEnabled(b);
			botonVersion3.setEnabled(b);
			botonVersion4.setEnabled(b);
			if (b)
			{
				botonSimular.setIcon(cargador.getIcono("botonComenzarSimulacion.gif"));
				botonSimular.setPressedIcon(cargador.getIcono("botonComenzarSimulacionPressed.gif"));
			}
			else
			{
				botonSimular.setIcon(cargador.getIcono("botonCancelarSimulacion.gif"));
				botonSimular.setPressedIcon(cargador.getIcono("botonCancelarSimulacionPressed.gif"));
			}

			labelNavegador.setVisible(b);
			barra.setVisible(b);
			botonInicio.setVisible(b);
			botonRetroceder.setVisible(b);
			botonAvanzar.setVisible(b);
			botonFin.setVisible(b);
	}		

	
}