import java.util.Random;

//CLASE QUE IMPLEMENTA EL GENERADOR DE NMEROS ALEATORIOS EMPLEADO EN LA SIMULACIN
public class GeneradorAleatorio
{
	private static int semilla; //Semilla empleada para generar los nmeros aleatorios
	private static Random random;
	
	//CONSTRUCTOR 1
	private GeneradorAleatorio()
	{
		semilla=(int) (Math.random()*10000);
		random=new Random(semilla);
	}
	
	//CONSTRUCTOR 2
	public GeneradorAleatorio(int semilla)
	{
		this.semilla=semilla;
		random=new Random(semilla);
	}

	//Devuelve el siguiente nmero aleatorio
	public static double nextDouble()
	{
		if(random==null) inicializarRandom();
		return random.nextDouble();
	}
	
	//Permite cambiar la semilla
	public static void setSemilla(int sem)
	{
		inicializarRandom(sem);
		semilla=sem;	
	}
	
	//Devuelve la semilla
	public static int getSemilla()
	{
		return semilla;
	
	}
	
	//Inicializa el objeto del tipo Random con una semilla elegida de forma aleatoria
	private static void inicializarRandom()
	{
		semilla=(int) (Math.random()*10000);
		random=new Random(semilla);
	}
	
	//Inicializa el objeto del tipo Random con una semilla predefinida
	private static void inicializarRandom(int sem)
	{
		semilla=sem;
		random=new Random(semilla);
	}
	
}