import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;


//CLASE QUE CONSTRUYE LA INTERFAZ GRFICA Y PERMITE INTERACTUAR CON LOS ELEMENTOS DE LA APLCACIN
public class InterfazGrafica extends JFrame implements ActionListener, MouseListener, MouseMotionListener, ChangeListener //,ObservadorDeProceso//, KeyListener
{
	private int version, estaciones;
	private double PG;
	
	private int ultimoTabbSeleccionado;
	private boolean modoEspera;
	

	//BLOQUES BASICOS DE LA APLICACIN:	
	private BloqueSimulacion bloqueSimulacion;
	private BloqueGrafico bloqueGrafico;
	private BloqueTexto bloqueTexto;
	private BloqueAudio bloqueAudio;
	
	
	//Imgenes e iconos:
	private ImageIcon checked, unchecked;
	

	//Elementos del men
	private JMenuBar menu; 
	private JMenuSuavizado menuArchivo, menuEdicion, menuAudio, menuVer, menuOpciones, menuSimulacion; 
	private JMenuItemSuavizado borrarAreaTexto, copiarAreaTexto;
	private JMenuItemSuavizado nuevaSimulacion, cambiarConfiguracionRed;
	private JMenuItemSuavizado conAudio, sinAudio;
	private JMenuItemSuavizado irSiguienteSlot, irSiguienteEvento, cambiarSlots;
	private JMenuItemSuavizado explicarTodas, explicarMostradas, explicarNinguna, explicarSeleccionada;
	private JMenuItemSuavizado verBarraBotones, ocultarInteriorTerminadores, mostrarAvisoLimiteCapacidad, activarMensajesGraficos, animarRecepcionDeCeldas;
	private JMenuItemSuavizado mostrarTodas, mostrarSeleccionadas, ocultarTodas, ocultarSeleccionadas;

	
	//Botones
	private Boton botonCopiarTexto, botonBorrarTexto, botonEvento, botonMostrar, botonOcultar;
	private BotonSlot botonSlot;
	private BotonAudio botonAudio;
	private BotonTexto botonExplicar;

	//Contenedores
	private JTabbedPane secciones; //Panel que contendr las pestaas
	private JPanel panelAuxiliar;
	private PanelBotones panelBotonesDeSimulacion;

	private ThreadSimulacion threadSimulacion;

	private CargadorDeImagenes cargador;

	//CONSTRUCTOR (CONSTRUYE LA INTERFAZ GRFICA)
	public InterfazGrafica()
	{	
		super(Constantes.titulo);
		cargador=cargador.getCargador();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);//LNEA AADIDA EN LA VERSIN APLICACIN (ESTA LNEA NO EXISTE EN LA VERSIN APPLET)
		 
		 
		 //Cambiamos el cursor a nuestro cursor por defecto:
		cambiarCursor(FactoriaMultimedia.cursorDefault);
	
			
		//CONFIGURACIN DE INICIO POR DEFECTO:
		version=Constantes.VERSION_INICIAL;
		estaciones=Constantes.NUMERO_ESTACIONES_INICIAL;
		PG=Constantes.PG_INICIAL;
		modoEspera=false;
		ultimoTabbSeleccionado=0;
		
				

		//Barra de Men:
		menu=new JMenuBar();
		
		//Secciones del men:
		menuArchivo=new JMenuSuavizado("Red");
		menuEdicion=new JMenuSuavizado("Texto");
		menuAudio=new JMenuSuavizado("Audio");
		menuSimulacion=new JMenuSuavizado("Simular");
		menuVer=new JMenuSuavizado("Ver");
		menuOpciones=new JMenuSuavizado("Opciones");


		//Para acceder al men pulsando Alt+...
		menuArchivo.setMnemonic('R');
		menuEdicion.setMnemonic('T');
		menuAudio.setMnemonic('A');
		menuSimulacion.setMnemonic('S');
		menuVer.setMnemonic('V');
		menuOpciones.setMnemonic('O');
		
		//Elementos de las secciones del men:
		nuevaSimulacion=new JMenuItemSuavizado("Nueva", cargador.getIcono("nuevo.gif"));
		borrarAreaTexto=new JMenuItemSuavizado("Borrar", cargador.getIcono("borrarTexto.gif"));
		copiarAreaTexto=new JMenuItemSuavizado("Copiar", cargador.getIcono("copiarTexto.gif"));
			
		irSiguienteSlot=new JMenuItemSuavizado("Slot",  cargador.getIcono("slot.gif"));
		irSiguienteEvento=new JMenuItemSuavizado("Evento",  cargador.getIcono("evento.gif"));
		cambiarSlots=new JMenuItemSuavizado("Cambiar nmero de slots");
		
		checked=cargador.getIcono("checked.gif");
		unchecked=cargador.getIcono("unchecked.gif");
		
		explicarTodas=new JMenuItemSuavizado("Explicar Todas", checked);
		explicarMostradas=new JMenuItemSuavizado("Explicar Visibles", unchecked);
		explicarNinguna=new JMenuItemSuavizado("No explicar Ninguna", unchecked);
		explicarSeleccionada=new JMenuItemSuavizado("Seleccionar estacin", unchecked);
		

		conAudio=new JMenuItemSuavizado("Seleccionar Estacin", cargador.getIcono("audio.gif"));
		sinAudio=new JMenuItemSuavizado("Cancelar Seleccin", cargador.getIcono("sinAudio.gif"));
		sinAudio.setEnabled(false);
		
		mostrarTodas=new JMenuItemSuavizado("Mostrar Todas", cargador.getIcono("mostrarTodas.gif"));
		mostrarSeleccionadas=new JMenuItemSuavizado("Mostrar Seleccionadas", cargador.getIcono("mostrarSeleccionadas.gif"));
		ocultarTodas=new JMenuItemSuavizado("Ocultar Todas", cargador.getIcono("ocultarTodas.gif"));
		ocultarSeleccionadas=new JMenuItemSuavizado("Ocultar Seleccionadas", cargador.getIcono("ocultarSeleccionadas.gif"));
		
		Icon icono=(Constantes.verBarraBotones? checked: unchecked);
		verBarraBotones=new JMenuItemSuavizado("Mostrar barra de botones", icono);
		icono=(Constantes.borrarEventosAntiguos? unchecked: checked);
	
		icono=(Constantes.ocultarInteriorTerminadores? checked: unchecked);
		ocultarInteriorTerminadores=new JMenuItemSuavizado("Terminadores cerrados", icono);
		
		icono=(Constantes.avisarDeLimiteTextoExcedido? checked: unchecked);
		mostrarAvisoLimiteCapacidad=new JMenuItemSuavizado("Mostrar aviso: Lmite de texto excedido", icono);
	
		icono=(Constantes.activarMensajesGraficos? checked: unchecked);
		activarMensajesGraficos=new JMenuItemSuavizado("Activar mensajes grficos", icono);
		
		icono=(Constantes.animarRecepcionDeCeldas? checked: unchecked);
		animarRecepcionDeCeldas=new JMenuItemSuavizado("Animar recepcin de celdas (Sim. Evento)", icono);
		
		cambiarConfiguracionRed=new JMenuItemSuavizado("Configuracin", cargador.getIcono("configuracion.gif"));
		
		nuevaSimulacion.addActionListener(this);
		borrarAreaTexto.addActionListener(this);
		copiarAreaTexto.addActionListener(this);
		conAudio.addActionListener(this);
		sinAudio.addActionListener(this);
		irSiguienteSlot.addActionListener(this);
		
		//Configuracin de acceso rpido a las funciones ms impotantes mediante teclado
		nuevaSimulacion.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1, 0));
		cambiarConfiguracionRed.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2, 0));
		irSiguienteEvento.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0));
		irSiguienteSlot.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, 0));
		cambiarSlots.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, KeyEvent.ALT_MASK));
		borrarAreaTexto.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, KeyEvent.CTRL_MASK));
		copiarAreaTexto.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, KeyEvent.CTRL_MASK));
		conAudio.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, KeyEvent.CTRL_MASK));

		irSiguienteEvento.addActionListener(this);
		cambiarSlots.addActionListener(this);
		explicarTodas.addActionListener(this);
		explicarMostradas.addActionListener(this);
		explicarNinguna.addActionListener(this);
		explicarSeleccionada.addActionListener(this);
		verBarraBotones.addActionListener(this);
		ocultarInteriorTerminadores.addActionListener(this);
		mostrarAvisoLimiteCapacidad.addActionListener(this);
		activarMensajesGraficos.addActionListener(this);
		animarRecepcionDeCeldas.addActionListener(this);
		cambiarConfiguracionRed.addActionListener(this);
		
//		acercaDeDqdbSim.addActionListener(this);
//		tutorial.addActionListener(this);
	
		mostrarTodas.addActionListener(this);
		ocultarTodas.addActionListener(this);
		ocultarSeleccionadas.addActionListener(this);
		mostrarSeleccionadas.addActionListener(this);
		
		menuArchivo.add(nuevaSimulacion);
		menuArchivo.add(cambiarConfiguracionRed);
		
		menuSimulacion.add(irSiguienteEvento);
		menuSimulacion.add(irSiguienteSlot);
		menuSimulacion.addSeparator();
		menuSimulacion.add(cambiarSlots);
		
		menuEdicion.add(borrarAreaTexto);
		menuEdicion.add(copiarAreaTexto);
		menuEdicion.addSeparator();
		menuEdicion.add(explicarTodas);
		menuEdicion.add(explicarMostradas);
		menuEdicion.add(explicarNinguna);
		menuEdicion.add(explicarSeleccionada);
			
		menuAudio.add(conAudio);
		menuAudio.add(sinAudio);
		menuVer.add(mostrarTodas);
		menuVer.add(ocultarTodas);
		menuVer.addSeparator();
		menuVer.add(mostrarSeleccionadas);	
		menuVer.add(ocultarSeleccionadas);
		
		menuOpciones.add(verBarraBotones);
		menuOpciones.add(ocultarInteriorTerminadores);
		menuOpciones.add(mostrarAvisoLimiteCapacidad);
		menuOpciones.add(activarMensajesGraficos);
		menuOpciones.add(animarRecepcionDeCeldas);
		
		menu.add(menuArchivo);
		menu.add(menuEdicion);
		menu.add(menuAudio);
		menu.add(menuSimulacion);
		menu.add(menuOpciones);
		menu.add(menuVer);
	
	
	
		bloqueSimulacion=new BloqueSimulacion(version, estaciones, PG, null);
	
		bloqueAudio=new BloqueAudio();
		bloqueGrafico=new BloqueGrafico(bloqueSimulacion, this, version, estaciones, PG, null, Constantes.borrarEventosAntiguos, Constantes.animarRecepcionDeCeldas);
		bloqueTexto=new BloqueTexto(this, bloqueGrafico.getArrayVisibilidad());
		BloqueEstadisticas panelEstadisticas=new BloqueEstadisticas(estaciones, version); //Panel que contiene todo lo referente a la parte de clculo de estadsticas

		bloqueSimulacion.addObserver(bloqueGrafico);
		bloqueSimulacion.addObserver(bloqueTexto);
		bloqueSimulacion.addObserver(bloqueAudio);
		
		
		secciones=new JTabbedPane(); //Contendr las 2 pestaas para cambiar a modo simulacin o modo estadsticas
		JSplitPane panelSeparador = new JSplitPane(JSplitPane.VERTICAL_SPLIT); //Panel que separa el marco de simulacin del rea de texto

		JScrollPane scrollerDeLaRed=new JScrollPane(bloqueGrafico);
		bloqueGrafico.setViewport(scrollerDeLaRed.getViewport());
	
		panelAuxiliar=new JPanel();	
		panelBotonesDeSimulacion=new PanelBotones(cargador.getImagen("backgroundBotones.png")); 	//Panel que muestra los botones de simulacin
		
	
		JPanel panelDeSimulacion=new JPanel();
		panelDeSimulacion.setLayout(new BorderLayout());
		panelDeSimulacion.add(menu, BorderLayout.NORTH);
		panelDeSimulacion.add(panelSeparador, BorderLayout.CENTER);
		secciones.addChangeListener(this);
		secciones.addTab("", cargador.getIcono("labelSimulacion.gif"), panelDeSimulacion, "Pantalla de Simulacin");
		secciones.addTab("", cargador.getIcono("labelEstadisticas.gif"), panelEstadisticas, "Pantalla de Estadsticas");
		secciones.addTab("", cargador.getIcono("labelMarcoTeorico.gif"), new JScrollPane(new BloqueHTML(Constantes.marcoTeorico)), "Pantalla conceptos tericos");
		secciones.addTab("", cargador.getIcono("labelAyuda.gif"), new JScrollPane(new BloqueHTML(Constantes.ayuda)), "Pantalla de Ayuda");
		secciones.addTab("", cargador.getIcono("labelAcercaDe.gif"), null, "Acerca de DQDB Sim");
		
	
		panelSeparador.setLeftComponent(scrollerDeLaRed);
		panelSeparador.setRightComponent(panelAuxiliar);
    	panelSeparador.setOneTouchExpandable(true);

   		panelSeparador.setDividerLocation(330);
  		panelSeparador.setDividerSize(10);
		panelSeparador.setPreferredSize(new Dimension(900, 600));
		
		panelBotonesDeSimulacion.add((botonCopiarTexto=new Boton(cargador.getIcono("botonCopiarTexto.gif"),cargador.getIcono("botonCopiarTextoPressed.gif"), this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonBorrarTexto=new Boton(cargador.getIcono("botonBorrarTexto.gif"), cargador.getIcono("botonBorrarTextoPressed.gif"), this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonEvento=new Boton(cargador.getIcono("botonEvento.gif"), cargador.getIcono("botonEventoPressed.gif"), cargador.getIcono("botonEventoDisabled.gif"),this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonSlot=new BotonSlot(cargador.getIcono("botonSlot.gif"),cargador.getIcono("botonSlotPressed.gif"),cargador.getIcono("botonSlotDisabled.gif"), this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonOcultar=new Boton(cargador.getIcono("botonOcultar.gif"),cargador.getIcono("botonOcultarPressed.gif"), this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonMostrar=new Boton(cargador.getIcono("botonMostrar.gif"),cargador.getIcono("botonMostrarPressed.gif"), this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonAudio=new BotonAudio(cargador.getIcono("botonAudio.gif"), cargador.getIcono("botonAudioAsignado.gif"), cargador.getIcono("botonAudioPressed.gif"), this)));
		panelBotonesDeSimulacion.add(Box.createRigidArea(new Dimension(20,0)));
		panelBotonesDeSimulacion.add((botonExplicar=new BotonTexto(cargador.getIcono("botonExplicarTodas.gif"),cargador.getIcono("botonExplicarTodasPressed.gif"), this)));

		botonSlot.addMouseMotionListener(this);

		panelAuxiliar.setLayout(new BoxLayout(panelAuxiliar, BoxLayout.Y_AXIS));
		JScrollPane scrollerBloqueTexto = new JScrollPane(bloqueTexto, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		panelAuxiliar.setBackground(Color.white);
		panelAuxiliar.add(panelBotonesDeSimulacion);
		panelAuxiliar.add(scrollerBloqueTexto);
		
		
		getContentPane().setLayout(new BorderLayout()); 
		getContentPane().add(secciones, BorderLayout.CENTER);
		
		pack();
		setVisible(true);
	}
	

	//Mtodo para crear la red nueva
	public void generarSistema(int version, int estaciones, double pgUnica, double[] arrayPg)
	{
		bloqueSimulacion.crearNuevaSimulacion(version, estaciones, pgUnica, arrayPg);

		//Reseteamos la configuacin inicial de los elementos
		explicarTodas.setIcon(checked);
		explicarMostradas.setIcon(unchecked);
		explicarNinguna.setIcon(unchecked);
		explicarSeleccionada.setIcon(unchecked);
		botonExplicar.setIcon(cargador.getIcono("botonExplicarTodas.gif"));
		botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarTodasPressed.gif"));
		botonExplicar.resetear();
		bloqueTexto.setModo(BloqueTexto.EXPLICAR_TODAS);
		
		botonAudio.resetear();
	}

	//Mtodo que permite cambiar el cursor
	 public void cambiarCursor(Cursor cursor)
	 {
//			Cursor cursor=cirsor;//cargador.getCursor(imagenCursor); //CAMBIAR PUNTERO A CURSOR POR DEFECTO
			setCursor(cursor);
	 }
	 
	 //Mtodo que establece la estacin monitorizada con audio
	 public void setEstacionMonitorizada(int idEstacion)
	 {
	 	bloqueAudio.setEstacionMonitorizada(idEstacion);
		
		//Hacemos que se muestre en el botn el nmero de estacin seleccionada;
		botonAudio.setEstacionMonitorizada(idEstacion);
		
		//Hacemos que se muestre en el men el nmero de estacin seleccionada
		conAudio.setText("Comentar Estacin "+idEstacion);
		
		//Habilitamos el elemento del men que permite cancelar la monitorizacin
		sinAudio.setEnabled(true);
	 }
	 
	 
	 //Mtodo que establece la estacin monitorizada por el rea de texto
	 public void setEstacionMonitorizadaTexto(int idEstacion)
	 {
	 	bloqueTexto.setEstacionMonitorizada(idEstacion);
		botonExplicar.setEstacionMonitorizada(idEstacion);
		
		//Hacemos que se muestre en el botn el nmero de estacin seleccionada
		explicarSeleccionada.setText("Seleccionar estacin ("+idEstacion+")");
	 }
	 
	 
	 //Mtodo para deshabilitar los elementos que permiten simular (en la barra de botones y en el men)
	 public void deshabilitarComandoSimular()
	 {
	 	botonEvento.setEnabled(false);
		botonSlot.setEnabled(false);
		irSiguienteEvento.setEnabled(false);
		irSiguienteSlot.setEnabled(false);
	 }
	 
	 
	 //Mtodo para habilitar los elementos que permiten simular (en la barra de botones y en el men)
	 public void habilitarComandoSimular()
	 {	
	 	botonEvento.setEnabled(true);
		botonSlot.setEnabled(true);
		irSiguienteEvento.setEnabled(true);
		irSiguienteSlot.setEnabled(true);
	}

	//Mtodo que ejecuta el inicio de la simulacin
	public void setInicioDeSimulacion()
	{
		deshabilitarComandoSimular();
		setTitle(Constantes.titulo+" - Simulando...");
		cambiarCursor(FactoriaMultimedia.cursorWait);
		bloqueGrafico.setModoEspera(true);
		modoEspera=true;
	}
	
	//Mtodo que ejecuta el final de la simulacin
	public void setFinDeSimulacion()
	{
		//Si la animacin del movimiento de celdas an est en curso, la simulacin no se finaliza an.
		if (bloqueGrafico.animacionEnCurso()) return;

		habilitarComandoSimular();
		setTitle(Constantes.titulo);
		bloqueGrafico.repaint();
		cambiarCursor(FactoriaMultimedia.cursorDefault);
		bloqueGrafico.setModoEspera(false);
		modoEspera=false;
	}
	
	
	//Mtodo que muesta la ventana de aviso de lmite de capacidad del rea de texto alcanzado, que pemite al usuario copiar el contenido al portapapeles antes de ser borrado
	public void mostrarLimiteAreaTextoExcedido()
	{
		//Si la opcin mostrar aviso est acivada muestra el aviso
		if (mostrarAvisoLimiteCapacidad.getIcon()==checked)
		{	
			PanelAvisoBloqueTexto aviso=new PanelAvisoBloqueTexto(this);
			aviso.setLocation(new Point((int)getLocation().getX()+100, (int)getLocation().getY()+100));
			aviso.setVisible(true);
		}
		//Si la opcin est desactivada borra el contenido directamente sin mostrar el aviso
		else liberarBloqueTexto(false);
	}
	
	
	//Mtodo que permite borrar elrea de texto, especificando si se desea o no copiar su contenido al portapapeles
	public void liberarBloqueTexto(boolean copiarAlPortapapeles)
	{
		if(copiarAlPortapapeles) bloqueTexto.copiarAlPortapapeles();
		bloqueTexto.resetear();
	}
	
	
	
	//Mtodo de la interfaz ActionListener
	public void actionPerformed(ActionEvent ev)
	{
		if(modoEspera) return;
		Object e=ev.getSource();
		
		//Si se estaba en modo de seleccin de estacin, lo finalizamos.
		bloqueGrafico.anularSeleccionActiva();

		//A Continuacin realizamos la accin correspondiente al componente sobre el que se ha hecho clic:
		
		
		if (e==nuevaSimulacion)
		{	
			PanelNuevaSimulacion panelNuevaSimulacion=new PanelNuevaSimulacion(this, true);
		}	
			
		else if (e==cambiarConfiguracionRed)
		{
			new PanelConfigurarEstaciones(this, bloqueSimulacion.getEstaciones());
		}
	
		else if(e==mostrarTodas)
		{
			bloqueGrafico.setVisibilidad(BloqueGrafico.VER_TODAS);
		}
		
		else if(e==ocultarTodas) bloqueGrafico.setVisibilidad(BloqueGrafico.OCULTAR_TODAS);
		else if(e==mostrarSeleccionadas) bloqueGrafico.setVisibilidad(BloqueGrafico.VER_SELECCIONADAS);
		else if(e==ocultarSeleccionadas) bloqueGrafico.setVisibilidad(BloqueGrafico.OCULTAR_SELECCIONADAS);
		else if(e==irSiguienteEvento)
		{
				threadSimulacion=new ThreadSimulacion(bloqueSimulacion, this);
				threadSimulacion.simularEvento();
				bloqueGrafico.repaint();
		}
		
		else if(e==irSiguienteSlot)
		{	
				threadSimulacion=new ThreadSimulacion(bloqueSimulacion, this);
				threadSimulacion.simularSlot(botonSlot.getNumeroSlots());
		}
		
		else if(e==cambiarSlots)
		{
			PanelConfiguracionDeSlots panelSlots=new PanelConfiguracionDeSlots(botonSlot, irSiguienteSlot);
			panelSlots.show(this,100, 100);

		}
		else if(e==explicarTodas)
		{
			if (explicarSeleccionada.getIcon()==checked)
			{
				bloqueGrafico.resetEstacionMonitorizadaTexto();
				bloqueTexto.unsetEstacionMonitorizada();
				botonExplicar.resetear();
			}
			explicarSeleccionada.setText("Seleccionar estacin");
			explicarTodas.setIcon(checked);
			explicarMostradas.setIcon(unchecked);
			explicarNinguna.setIcon(unchecked);
			explicarSeleccionada.setIcon(unchecked);
			botonExplicar.setIcon(cargador.getIcono("botonExplicarTodas.gif"));
			botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarTodasPressed.gif"));
			bloqueTexto.setModo(BloqueTexto.EXPLICAR_TODAS);
		}	
		else if(e==explicarMostradas)
		{
			if (explicarSeleccionada.getIcon()==checked)
			{
				bloqueGrafico.resetEstacionMonitorizadaTexto();
				bloqueTexto.unsetEstacionMonitorizada();
				botonExplicar.resetear();
			}
			explicarSeleccionada.setText("Seleccionar estacin");
			explicarTodas.setIcon(unchecked);
			explicarMostradas.setIcon(checked);
			explicarNinguna.setIcon(unchecked);	
			explicarSeleccionada.setIcon(unchecked);		
			botonExplicar.setIcon(cargador.getIcono("botonExplicarVisibles.gif"));
			botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarVisiblesPressed.gif"));
			bloqueTexto.setModo(BloqueTexto.EXPLICAR_VISIBLES);
		}
		else if(e==explicarNinguna)
		{
			if (explicarSeleccionada.getIcon()==checked)
			{
				bloqueGrafico.resetEstacionMonitorizadaTexto();
				bloqueTexto.unsetEstacionMonitorizada();
				botonExplicar.resetear();
			}
			explicarSeleccionada.setText("Seleccionar estacin");
			explicarTodas.setIcon(unchecked);
			explicarMostradas.setIcon(unchecked);
			explicarNinguna.setIcon(checked);
			explicarSeleccionada.setIcon(unchecked);
			botonExplicar.setIcon(cargador.getIcono("botonNoExplicarNinguna.gif"));
			botonExplicar.setPressedIcon(cargador.getIcono("botonNoExplicarNingunaPressed.gif"));
			bloqueTexto.setModo(BloqueTexto.EXPLICAR_NINGUNA);
		}	
		
		else if(e==explicarSeleccionada)
		{
	
			explicarTodas.setIcon(unchecked);
			explicarMostradas.setIcon(unchecked);
			explicarNinguna.setIcon(unchecked);
			explicarSeleccionada.setIcon(checked);
			botonExplicar.setIcon(cargador.getIcono("botonExplicarSeleccionada.gif"));
			botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarSeleccionadaPressed.gif"));
			bloqueTexto.setModo(BloqueTexto.EXPLICAR_SELECCIONADA);
			bloqueGrafico.setModoSeleccionTexto();
		}	
		
		
		else if (e==borrarAreaTexto) bloqueTexto.resetear();	
		else if (e==copiarAreaTexto) bloqueTexto.copiarAlPortapapeles();			
		
		else if (e==conAudio)
		{
			//Si ya hay una estacion monitorizada este botn no hace nada hasta que la canceles
			if(botonAudio.tieneEstacionMonitorizada()) return;
			
			boolean modoDeSeleccion=botonAudio.cambiarModo();
			if(modoDeSeleccion) bloqueGrafico.setModoSeleccionAudio();
		}
			
		else if (e==sinAudio)
		{
			sinAudio.setEnabled(false);
			conAudio.setText("Seleccionar Estacin");
			boolean modoDeSeleccion=botonAudio.cambiarModo();
			bloqueAudio.unsetEstacionMonitorizada();
			bloqueGrafico.resetEstacionMonitorizadaAudio();
		}
			
		else if (e==verBarraBotones)
		{
			if (panelAuxiliar.getComponent(0)!=panelBotonesDeSimulacion)
			{
					verBarraBotones.setIcon(checked);
					panelAuxiliar.add(panelBotonesDeSimulacion, 0);
			}
			else
			{
					verBarraBotones.setIcon(unchecked);
					panelAuxiliar.remove(panelBotonesDeSimulacion);
			}
			panelAuxiliar.validate();
		}
			
		else if (e==ocultarInteriorTerminadores)
		{
			Icon nuevoIcono=(ocultarInteriorTerminadores.getIcon()==checked? unchecked: checked);
			ocultarInteriorTerminadores.setIcon(nuevoIcono);
			if(nuevoIcono==checked) bloqueGrafico.setOcultarTerminadores(true);
			else bloqueGrafico.setOcultarTerminadores(false);
		}
		
		else if (e==mostrarAvisoLimiteCapacidad)
		{
			Icon nuevoIcono=(mostrarAvisoLimiteCapacidad.getIcon()==checked? unchecked: checked);
			mostrarAvisoLimiteCapacidad.setIcon(nuevoIcono);
		}
				
		else if (e==animarRecepcionDeCeldas)
		{
				
			Icon nuevoIcono=(animarRecepcionDeCeldas.getIcon()==checked? unchecked: checked);
			animarRecepcionDeCeldas.setIcon(nuevoIcono);
			if(nuevoIcono==checked) bloqueGrafico.setAnimarRecepcionDeCeldas(true);
			else bloqueGrafico.setAnimarRecepcionDeCeldas(false);
		}
			
		else if (e==activarMensajesGraficos)
		{
			Icon nuevoIcono=(activarMensajesGraficos.getIcon()==checked? unchecked: checked);
			activarMensajesGraficos.setIcon(nuevoIcono);
			if(nuevoIcono==checked) bloqueGrafico.setMensajesGraficos(true);
			else bloqueGrafico.setMensajesGraficos(false);
		}
	}
	
	
	
	//Mtodos de la interfaz MouseListener
	public void mousePressed(MouseEvent ev)
	{
		Object source=ev.getSource();
		if(modoEspera && (source==botonSlot || source==botonEvento || source==irSiguienteSlot || source==irSiguienteEvento)) return;
		bloqueGrafico.anularSeleccionActiva();
		
		
		//Si se ha pulsado el botn "EXPLICAR" rotamos al siguiente modo de explicacin
		if(source==botonExplicar)
		{
			if (explicarTodas.getIcon()==checked)
			{
				explicarSeleccionada.setText("Seleccionar estacin");
				explicarTodas.setIcon(unchecked);
				explicarMostradas.setIcon(checked);
				explicarNinguna.setIcon(unchecked);
				explicarSeleccionada.setIcon(unchecked);
				botonExplicar.setIcon(cargador.getIcono("botonExplicarVisibles.gif"));
				botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarVisiblesPressed.gif"));
				bloqueTexto.setModo(BloqueTexto.EXPLICAR_VISIBLES);
			}
			else if (explicarMostradas.getIcon()==checked)
			{
				explicarTodas.setIcon(unchecked);
				explicarMostradas.setIcon(unchecked);
				explicarNinguna.setIcon(unchecked);
				explicarSeleccionada.setIcon(checked);
				botonExplicar.setIcon(cargador.getIcono("botonExplicarSeleccionada.gif"));
				botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarSeleccionadaPressed.gif"));
				bloqueTexto.setModo(BloqueTexto.EXPLICAR_SELECCIONADA);
				bloqueGrafico.setModoSeleccionTexto();
			}
			else if (explicarSeleccionada.getIcon()==checked)
			{
				explicarSeleccionada.setText("Seleccionar estacin");
				bloqueGrafico.resetEstacionMonitorizadaTexto();
				bloqueTexto.unsetEstacionMonitorizada();
				botonExplicar.resetear();
				explicarTodas.setIcon(unchecked);
				explicarMostradas.setIcon(unchecked);
				explicarNinguna.setIcon(checked);
				explicarSeleccionada.setIcon(unchecked);
				botonExplicar.setIcon(cargador.getIcono("botonNoExplicarNinguna.gif"));
				botonExplicar.setPressedIcon(cargador.getIcono("botonNoExplicarNingunaPressed.gif"));
				bloqueTexto.setModo(BloqueTexto.EXPLICAR_NINGUNA);
			}
			
			else if (explicarNinguna.getIcon()==checked)
			{
				explicarSeleccionada.setText("Seleccionar estacin");
				explicarTodas.setIcon(checked);
				explicarMostradas.setIcon(unchecked);
				explicarNinguna.setIcon(unchecked);
				explicarSeleccionada.setIcon(unchecked);
				botonExplicar.setIcon(cargador.getIcono("botonExplicarTodas.gif"));
				botonExplicar.setPressedIcon(cargador.getIcono("botonExplicarTodasPressed.gif"));
				bloqueTexto.setModo(BloqueTexto.EXPLICAR_TODAS);				

			}
		}	
		else if(source==botonEvento)
		{
			if(!botonEvento.isEnabled() || !botonSlot.isEnabled()) return;
			setInicioDeSimulacion();
			botonEvento.setEnabled(false);
			botonSlot.setEnabled(false);
			threadSimulacion=new ThreadSimulacion(bloqueSimulacion, this);
			threadSimulacion.simularEvento();
		}
		
		else if(source==botonSlot)
		{
			if(!botonSlot.isEnabled() || !botonEvento.isEnabled()) return;
			if (ev.getY()>botonSlot.getIcon().getIconHeight()-25)
			{
				PanelConfiguracionDeSlots panelSlots=new PanelConfiguracionDeSlots(botonSlot, irSiguienteSlot);
				panelSlots.show(ev.getComponent(), ev.getX(), ev.getY());

			}
			else
			{
					botonSlot.setEnabled(false);
					botonEvento.setEnabled(false);
					threadSimulacion=new ThreadSimulacion(bloqueSimulacion, this);
					threadSimulacion.simularSlot(botonSlot.getNumeroSlots());
			}
		}
		
		else if(source==botonMostrar)
		{
			if(ev.getClickCount()==1) bloqueGrafico.setVisibilidad(BloqueGrafico.VER_SELECCIONADAS);
			else if (ev.getClickCount()==2)	bloqueGrafico.setVisibilidad(BloqueGrafico.VER_TODAS);
		}
		
		else if(source==botonOcultar)
		{
			if(ev.getClickCount()==1) bloqueGrafico.setVisibilidad(BloqueGrafico.OCULTAR_SELECCIONADAS);
			else if (ev.getClickCount()==2) bloqueGrafico.setVisibilidad(BloqueGrafico.OCULTAR_TODAS);
		}
		
		else if (source==botonBorrarTexto)
		{	
			bloqueTexto.resetear();	
		}
			
		else if (source==botonCopiarTexto)
		{
				bloqueTexto.copiarAlPortapapeles();
				
		}
		else if (source==botonAudio)
		{			
				boolean modoDeSeleccion=botonAudio.cambiarModo();
				if (modoDeSeleccion)
				{

					bloqueGrafico.setModoSeleccionAudio();
				}
				else
				{
					bloqueAudio.unsetEstacionMonitorizada();
					bloqueGrafico.resetEstacionMonitorizadaAudio();
					conAudio.setText("Seleccionar Estacin");
					sinAudio.setEnabled(false);
				}
		}
	}
	
	public void mouseExited(MouseEvent ev)
	{
		if (ev.getSource()==botonSlot)
		{
			//Si se el cursor ha salido del rea del botnSlots, establecemos el cusor por defecto (por si se sali de la zona que muestra el cursor "mano")
			if(botonSlot.isEnabled()==true) setCursor(FactoriaMultimedia.cursorDefault);
		}
	}
	
	public void mouseClicked(MouseEvent ev){}
	public void mouseReleased(MouseEvent ev){}
	public void mouseEntered(MouseEvent ev){}

	
	
	
	
	//Mtodos de la interfaz MouseMotionListener
	public void mouseDragged(MouseEvent ev){}
	public void mouseMoved(MouseEvent ev)
	{
		
		if (ev.getSource()==botonSlot)
		{
			//Si el botn SLOTS est desactivado no hacemos nada
			if(!botonSlot.isEnabled()) return;
			
			//Si el botn SLOTS est activado y el cursor est sobe la zona del botn que permite abrir la ventana de configuacin de slots, establecemos el cursor "mano".
			if (ev.getY()>botonSlot.getIcon().getIconHeight()-25)
				setCursor(FactoriaMultimedia.cursorHand);
			//En caso contario establecemos el curso por defecto
			else
				setCursor(FactoriaMultimedia.cursorDefault);
		}
	}
	
	
	//Mtodo de la interfaz ChangeListener
	public void stateChanged(ChangeEvent ev)
	{
		//Si el componente es null signifcar que se ha pulsado la pestaa DQDB Sim. Po tanto mostramos la ventana emegente de crditos
		if (secciones.getSelectedComponent()==null)
		{
			//Mostramos la ventana de crditos
			PanelAcercaDeDQDB panel=new PanelAcercaDeDQDB(this);
			panel.setLocation(new Point((int)getLocation().getX()+100, (int)getLocation().getY()+100));
			panel.setVisible(true);
			
			//Al cerrar la ventana se volver a la seccin que hubiera activa en el momento en que se puls la pestaa DQDB Sim
			secciones.setSelectedIndex(ultimoTabbSeleccionado);
			return;
		}
		
		//Si el componente es distinto de null significar que es uno de los 4 bloques principales.
		//Actualizamos por tanto el ndice del ltimo bloque seleccionado (que ser ste), para que si se pulsa la pestaa DQDB Sim, al cerrar la ventana, se vuelva a este bloque automticamente.
		ultimoTabbSeleccionado=secciones.getSelectedIndex();
	}
}