import java.lang.Thread;

//CLASE QUE IMPLEMENTA EL THREAD ENCARGADOR DE REALIZAR LAS SIMULACIONES DE FORMA CONCURRENTE, PARA EVITAR QUE LA APLICACIN SE QUEDE "BLOQUEADA" HASTA QUE FINALIZA LA SIMULACIN
public class ThreadSimulacion extends Thread
{
	private BloqueSimulacion bloqueSimulacion;
	private InterfazGrafica interfaz;
	private int slotsCompletosASimular;
	
	//CONSTRUCTOR
	public ThreadSimulacion(BloqueSimulacion bloqueSimulacion, InterfazGrafica interfaz)
	{
		this.bloqueSimulacion=bloqueSimulacion;
		this.interfaz=interfaz;
	}
	
	//SIMULAR UN EVENTO
	public void simularEvento()
	{
		slotsCompletosASimular=0;
		start();
	}
	
	//SIMULAR 'X' SLOTS
	public void simularSlot(int slots)
	{
		slotsCompletosASimular=slots;
		start();
	}
	
	//Mtodo que realiza la simulacin de forma concurrente
	public void run()
	{		
		interfaz.setTitle(Constantes.titulo+" -  Simulando...");
		
		//Si se ha seleccionado simular evento se simula 1 evento
		if(slotsCompletosASimular==0) bloqueSimulacion.simularEvento(false);
		
		//Si se ha seleccionado simular slots se simula el nmeo de slots especificado.
		else
			bloqueSimulacion.simularSlot(slotsCompletosASimular);
			
		interfaz.setFinDeSimulacion(); //Si no hay animacin en curso esto habilitar los botones de simulacion, pero si hay animacion en curso interfazGrafica har caso omiso y el bloque grafico se encargar de habilitar los botones al finalizar la animacin

	}
}