import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.font.*;

//CLASE QUE DEFINE EL BOTN "AUDIO"
public class BotonAudio extends Boton
{
	private ImageIcon iconoUnset, iconoSet;
	private String estacionAsignada; //Indica la estacin que est siendo monitorizada con audio
	
	public BotonAudio(ImageIcon iconoUnset, ImageIcon iconoSet, ImageIcon iconoPressed, MouseListener listener)
	{
		super(iconoUnset, iconoPressed, listener);
		this.iconoUnset=iconoUnset;
		this.iconoSet=iconoSet;
	}
	
	//Mtodo empleado para que el botn deje de mostrar el nmero de estacin monitorizada (empleado al deseleccionar la estacin)
	public void resetear()
	{
		estacionAsignada=null;
		setIcon(iconoUnset);	
		repaint();
	}
	
	//Mtodo empleado para que el botn muestre el nmero de estacin que est monitorizada con audio
	public void setEstacionMonitorizada(int idEstacion)
	{
		setIcon(iconoSet);
		estacionAsignada=""+idEstacion;
		repaint();
	}
	
	//Mtodo para comprobar si el botn est mostrando un nmero de estacin monitorizada con audio
	public boolean tieneEstacionMonitorizada()
	{
		if(estacionAsignada!=null) return true;
		return false;
	}
	
	//Mtodo empleado por la clase InterfazGrafica para gestionar el modo de seleccin de estacin a monitorizar
	public boolean cambiarModo() 
	{
		if(estacionAsignada==null) return true; 
		
		estacionAsignada=null;
		setIcon(iconoUnset);
		return false;
		
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		
		if (estacionAsignada!=null)
		{
			Graphics2D graphics2d = (Graphics2D)g;
			Font fuente=new Font("Arial", Font.BOLD, 11);
			graphics2d.setFont(fuente);
		
			//Escribimos el nmero de estacin centrado y suavizado
			graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			FontRenderContext frc = graphics2d.getFontRenderContext();
			LineMetrics linemetrics = fuente.getLineMetrics(estacionAsignada, frc);
			int largo = (int)fuente.getStringBounds(estacionAsignada, frc).getWidth();
			int desfaseX=(iconoSet.getIconWidth()-largo)/2;
			graphics2d.drawString("ESTACIN:", 6, 58);
			graphics2d.drawString(estacionAsignada, desfaseX, 68);
		}
	}
}
