import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.font.*;

//CLASE QUE IMPLEMENTA EL BOTN "EXPLICAR"
public class BotonTexto extends Boton
{
	private String estacionAsignada;
	
	
	//CONSTRUCTOR
	public BotonTexto(ImageIcon icono, ImageIcon iconoPressed, MouseListener listener)
	{
		super(icono, iconoPressed, listener);
	}
	
	//Mtodo para establecer la estacin a explicar
	public void setEstacionMonitorizada(int idEstacion)
	{
		estacionAsignada=""+idEstacion;
		repaint();
	}
	
	//Mtodo para cancelar la estacin seleccionada
	public void resetear()
	{
		estacionAsignada=null;
		repaint();
	}
	
	//Sobreescribe el mtodo paintComponent para mostrar el nmero de estacin suavizado
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		
		if (estacionAsignada!=null)
		{
			Graphics2D graphics2d = (Graphics2D)g;
			Font fuente=new Font("Arial", Font.BOLD, 14);
			graphics2d.setFont(fuente);
			graphics2d.setColor(Color.white);
		
			//Escribimos el nmero de estacin centrado y suavizado
			graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			FontRenderContext frc = graphics2d.getFontRenderContext();
			LineMetrics linemetrics = fuente.getLineMetrics(estacionAsignada, frc);
			int largo = (int)fuente.getStringBounds(estacionAsignada, frc).getWidth();
			int desfaseX=(getIcon().getIconWidth()-largo)/2-4;
			graphics2d.drawString(estacionAsignada, desfaseX, 55);
		}
	
	}
}