import javax.swing.*;
import java.awt.*;
import java.util.*;

//CLASE QUE IMPLEMENTA LA TABLA DE ESTACIONES/PG EMPLEADA POR PanelPg
public class TablaConfiguracion extends JTable
{
	private Object[][] datos;
	
	//CONSTRUCTOR
	public TablaConfiguracion(Object[][] datos, String[] nombreColumnas)
	{
		super(datos, nombreColumnas);
		this.datos=datos;
		
		//Permitimos seleccionar intervalos
		setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION); 
	}

	//Sobreescribe el mtodo paintComponent para que suavice el texto que contiene
	public void paintComponent(Graphics g)
	{
		if (g instanceof Graphics2D)
		{
      		Graphics2D g2 = (Graphics2D)g;
      		Map<Object, Object> rMap = new HashMap<Object, Object>();
        	Object key = RenderingHints.KEY_ANTIALIASING;
        	Object value = RenderingHints.VALUE_ANTIALIAS_ON;
        	rMap.put(key, value);
        	g2.addRenderingHints(rMap);
    	}
    	super.paintComponent(g);
	}
	
	//Sobreescribimos el mtodo isCellEditable para indicar que las celdas no son editables
	public boolean isCellEditable(int fila, int columna) 
	{
	       return false;      
	}
	
	
}
