
//CLASE QUE DEFINE LAS CELDAS (UNIDADES BSICAS DE DATOS DE LONGITUD FIJA)
public class Celda
{
	private boolean ocupada;
	private boolean peticion;
	private Datos datos;

	//CONSTRUCTOR 1
	public Celda()
	{
	
		ocupada=false;
		peticion=false;
		datos=null;
	}
	
	//CONSTRUCTOR 2
	public Celda(boolean ocupada, boolean peticion, Datos datos)
	{
		this.ocupada=ocupada;
		this.peticion=peticion;
		this.datos=datos;
	}
	
	//Este mtodo permite poner a true o false el valor del campo "Ocupada" de la celda
	public void setOcupada(boolean valor)  
	{
		ocupada=valor;
	}
	
	//Este mtodo permite poner a true o false el valor del campo "Peticin" de la celda
	public void setPeticion(boolean valor) 
	{
		peticion=valor;
	}
	
	//Este campo permite insertar o borrar datos (en realidad lo que se inserta/borra es el origen y destino de los datos) en la celda
	public void setDatos(Datos datos) 
	{
		this.datos=datos;
		if(datos!=null) ocupada=true;
	}
	
	//Este mtodo devuelve el valor del campo "Ocupado"
	public boolean getOcupada() 
	{
		return ocupada;
	}
	
	//Este mtodo devuelve el valor del campo "Peticion"
	public boolean getPeticion() 
	{
		return peticion;
	}
	
	//Este mtodo devuelve el valor del campo "Datos"
	public Datos getDatos() 
	{
		return datos;
	}
	
	//Devuelve una representacin de la celda en formato String
	public String toString()
	{
		String dat;
		if(datos==null) dat="null";
		else dat="<< "+datos.getOrigen()+" , "+datos.getDestino()+" >>";
		return "((( O="+getOcupada()+" |  P="+getPeticion()+"  |  "+ dat+"  )))";

	}
	
	//Devuelve una representacin de los datos que contiene la celda en formato String
	public String getStringDatos()
	{
		String dat;
		if(datos==null) dat="null";
		else dat=datos.toString();
		return dat;
	}
	
	//Devuelve una celda clnica (idntica a esta)
	public Celda clonar()
	{
		Datos datos=null;
		if(this.datos!=null) datos=new Datos(this.datos.getOrigen(), this.datos.getDestino());
		return new Celda(ocupada, peticion, datos);
	}
	
}

