
//INTERFAZ QUE DEBEN IMPLEMENTAR TODAS AQUELLAS CLASES QUE PRETENDAN SER NOTICADAS POR BloqueSimulacion DE LOS EVENTOS QUE SURJAN EN LAS ESTACIONES DURANTE LA SIMULACIN
//De esta forma la aplicacin resulta escalable, pudiendo crear nuevos "observadores" con distintas funcionalidades e integrarlos en la aplicacin con tan slo aadir una lnea de cdigo que inserte el nuevo "observador" en la lista de observadores que mantiene el BloqueSimulacion
public interface DQDB_Observer 
{
	//NOTA: El parmetros de estado introducidos en la llamada a los mtodos de la interfaz por el BloqueSimulacion correspondern a valor pblico y esttico de la clase Estacin, a fin de que los observadores puedan determinar qu evento concreto est notificando dicho parmetro de entrada
	//		Sera til revisar el cdigo de BloqueTexto o BloqueAudio (que implementan esta interfaz) para comprender de forma rpida cmo es la dinmica de funcionamiento de los observadores.
	
	//notifica el resultado de comprobar si el usuario de la estacin indicada ha generado datos o no
	public void notificarDatosGenerados(int idslot, int idevento, int idEstacion, int evento, Datos datos);
	
	//notifica el resultado de comprobar si alguno de los Controles de Acceso acepta o rechaza datos procedentes del usuario
	public void notificarRecepcionDeDatos(int idslot, int idevento, int idEstacion, int estadoRecepcion, Datos datos);
	
	//notifica el resultado de comprobar si la estacin indicada ha recibido/enviado celda o no
	public void notificarCeldasRecibidas(int version, int idslot, int idevento, int idEstacion, Celda celdaEntradaBus1, Celda celdaSalidaBus1, Celda celdaEntradaBus2, Celda celdaSalidaBus2, boolean incrementaVacias1, boolean incrementaVacias2);
	
	//notifica el resultado de comprobar si el Control de Acceso correspondiente enva datos al usuario porcedentes de una celda ocupada
	public void notificarContenidoCeldas(int idslot, int idevento, int idEstacion, int estadoCelda1, int estadoCelda2);
	
	//notifica el resultado de comprobar si los Controles de Acceso insertan datos o no en la celda que han recibido
	public void notificarInsercionDeDatosPendientes(int idslot, int idevento, int idEstacion, int estadoDatos1, int estadoDatos2);
	
	//notifica el resultado de comprobar si los Controles de Acceso solicitan a su correspondiente opuesto el envo de una peticin "ro arriba"
	public void notificarSolicitudEnvioDePeticion(int idslot, int idevento, int idEstacion, int estadoPeticion1, int estadoPeticion2);
	
	//notifica el resultado de comprobar si los Comtroles de Acceso envan el valor de su contador de peticiones a su respectivo CA opuesto
	public void notificarEnvioRC(int idslot, int idevento, int idEstacion, int estadoRC1, int estadoRC2, int[] contadorPeticiones, int[] contadorVacias, int[] cuentaAtras);
	
	//notifica el resultado de comprobar si los Controles de Acceso han logrado insertar una peticin en la celda que han recibido
	public void notificarEnvioDePeticion(int idslot, int idevento, int idEstacion, int estadoPeticion1, int estadoPeticion2);

	//notifica el resultado de comprobar si el usuario ha enviado la seal de "borrar celda" a algn Control de Acceso
	public void notificarBorradoCelda(int idslot, int idevento, int idEstacion, int estadoCA1, int estadoCA2);
	
	//notifica a los observadores que se va a iniciar una nueva simulacin, con el objetivo de que reseteen todas las variables relacionadas con la simulacin anterior
	public void notificarNuevaSimulacion(int version, int numeroEstaciones,  double pgUnica, double[] arrayPg, Estacion[] estaciones);
}