import java.util.*;
import javax.swing.table.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.event.*;

//CLASE QUE IMPLEMENTA EL PANEL DE CONFIGURACIN DE LA PG DE LAS ESTACIONES DE UNA RED QUE VA A SER CREADA
public class PanelPg extends JDialog implements MouseListener, ListSelectionListener
{	
	private TablaConfiguracion tabla;
	private Boton botonAceptar, botonAgregar, botonCancelar;
	private TextFieldNumerico estacion, valorPgEstacion;
	private TextFieldNumerico intervalo1, intervalo2, valorPgIntervalo;
	private JLabel avisos;
	private double[] listaPg;
	private PanelNuevaSimulacion panelNuevaSimulacion;
	
	//CONSTRUCTOR
	public  PanelPg(PanelNuevaSimulacion panelNuevaSimulacion, int estaciones)
	{
		super(new JFrame(), "Configuracin de la red", true);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		
		this.panelNuevaSimulacion=panelNuevaSimulacion;
		this.listaPg=new double[estaciones];
		Object[][] datos=new Object[estaciones][2];
	
		for(int i=0; i<estaciones; i++)
		{
			listaPg[i]=Constantes.PG_INICIAL;
			datos[i][0]=i+1;
			datos[i][1]=Constantes.PG_INICIAL;
		}
		
		setSize(new Dimension(416,372));
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.X_AXIS));
		PanelConFondo panel=new PanelConFondo("panelConfigurar.gif");
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));

	 	final String[] cabecera = {"ESTACIN", "PG"};
		
	    tabla= new TablaConfiguracion(datos, cabecera);

	    JScrollPane scrollPane1 = new JScrollPane(tabla);
		
		Font font=new Font("ARIAL", Font.BOLD, 16);
		tabla.setFont(font);

		JPanel panelTabla=new JPanel();
		panelTabla.setLayout(new BoxLayout(panelTabla, BoxLayout.Y_AXIS));
		panelTabla.setOpaque(false);
		
		Dimension dim=new Dimension(180,260);
		scrollPane1.setPreferredSize(dim);
		scrollPane1.setMaximumSize(dim);
		scrollPane1.setMinimumSize(dim);
		
		panelTabla.add(Box.createRigidArea(new Dimension(0, 45)));
		panelTabla.add(scrollPane1);
		panelTabla.setAlignmentX(0f);
		panelTabla.setAlignmentY(0f);

		panel.add(Box.createRigidArea(new Dimension(10, 0)));
		panel.add(panelTabla);
		getContentPane().add(panel);
		
		tabla.setOpaque(false);
		tabla.getSelectionModel().addListSelectionListener(this); //Para detectar las selecciones en la tabla
		tabla.setDragEnabled(false);
		
		avisos=new JLabel();
		avisos.setForeground(Color.red);
	
		botonAceptar=new Boton(CargadorDeImagenes.getCargador().getIcono("botonAceptar2.gif"), CargadorDeImagenes.getCargador().getIcono("botonAceptarPressed2.gif"), this);
		botonAgregar=new Boton(CargadorDeImagenes.getCargador().getIcono("botonCambiar.gif"), CargadorDeImagenes.getCargador().getIcono("botonCambiarPressed.gif"), this);
		botonCancelar=new Boton(CargadorDeImagenes.getCargador().getIcono("botonCancelar2.gif"), CargadorDeImagenes.getCargador().getIcono("botonCancelarPressed2.gif"), this);
		
		JPanel panelIntervalo =new JPanel();
		JPanel panelLista=new JPanel();
		JPanel panelBotones=new JPanel();
		
		intervalo1=new TextFieldNumerico(1, 3);
		intervalo2=new TextFieldNumerico(1, 3);
		valorPgIntervalo= new TextFieldNumerico(2, 3);
		estacion=new TextFieldNumerico(1,5);
		valorPgEstacion=new TextFieldNumerico(2, 3);
		
		
		panelIntervalo.add(intervalo1);
		panelIntervalo.add(new JLabel(" - "));
		panelIntervalo.add(intervalo2);
		panelIntervalo.add(new JLabel(" = "));
		panelIntervalo.add(valorPgIntervalo);
	
		dim=new Dimension(218,30);
		panelIntervalo.setPreferredSize(dim);
		panelIntervalo.setMaximumSize(dim);
		panelIntervalo.setMinimumSize(dim);
		panelLista.setPreferredSize(dim);
		panelLista.setMaximumSize(dim);
		panelLista.setMinimumSize(dim);
		
		panelIntervalo.setOpaque(false);
		panelLista.setOpaque(false);
		panelBotones.setOpaque(false);
			
		panelLista.add(Box.createRigidArea(new Dimension(29,0)));
		panelLista.add(estacion);
		panelLista.add(new JLabel(" = "));
		panelLista.add(valorPgEstacion);
		

		panelBotones.setLayout(new BoxLayout(panelBotones, BoxLayout.X_AXIS));
		panelBotones.add(botonAceptar);
		panelBotones.add(Box.createRigidArea(new Dimension(35,0)));
		panelBotones.add(botonCancelar);
		
		
		panelBotones.setAlignmentY(0f);
		panelIntervalo.setAlignmentY(0f);
		panelLista.setAlignmentY(0f);
	
		panelBotones.setAlignmentX(0.5f);
		panelIntervalo.setAlignmentX(0.5f);
		panelLista.setAlignmentX(0.5f);
		botonAgregar.setAlignmentX(0.5f);
		avisos.setAlignmentX(0.5f);
		JPanel contenedor=new JPanel();
		contenedor.setOpaque(false);
		contenedor.setAlignmentX(0f);
		contenedor.setAlignmentY(0f);
		contenedor.setLayout(new BoxLayout(contenedor, BoxLayout.Y_AXIS));
		
		contenedor.add(Box.createRigidArea(new Dimension(0,68)));
		contenedor.add(panelLista);
		contenedor.add(Box.createRigidArea(new Dimension(0,10)));
		contenedor.add(panelIntervalo);
		contenedor.add(Box.createRigidArea(new Dimension(0,15)));
		contenedor.add(botonAgregar);
		contenedor.add(Box.createRigidArea(new Dimension(0,28)));
		contenedor.add(panelBotones);
		contenedor.add(Box.createRigidArea(new Dimension(0,28)));
		contenedor.add(avisos);

		panel.add(contenedor);	
	
		setResizable(false);
		setVisible(true);	
	}
	
	
	//Mtodo encargado de detectar las estaciones que han sido seleccionadas al pulsar sobre la tabla, cargando dicha informacin en los campos de texto de asignacin de PGs.
	//Es decir, al seleccionar las estaciones 3, 4 y 5, en el campo de texto "DESDE" se colocar la estacin 3 automticamente; y en el campo "HASTA", la estacin 5. De esta forma el usuario slo tiene que escribir la PG, ahorrando tiempo
	public void valueChanged(ListSelectionEvent e) {
	      ListSelectionModel lsm = (ListSelectionModel)e.getSource();
	      if (lsm.isSelectionEmpty())
		  {
	          	estacion.setText("");
			  	intervalo1.setText("");
				intervalo2.setText("");
	      } 
		  else 
		  {
	          int inicioSeleccion = lsm.getMinSelectionIndex()+1;
			  int finSeleccion = lsm.getMaxSelectionIndex()+1;
			  
			  if (inicioSeleccion==finSeleccion)
			  {
			  	estacion.setText(""+inicioSeleccion);
			  	intervalo1.setText("");
				intervalo2.setText("");
			  }
			  else
			  {
			  	estacion.setText("");
			  	intervalo1.setText(""+inicioSeleccion);
				intervalo2.setText(""+finSeleccion);
			  }
	         
	      }
	  }
	
	
	//Mtodos de la interfaz MouseListener
	public void mousePressed(MouseEvent e)
	{
	}
	
	public void mouseReleased(MouseEvent e)
	{
		Object implicado=e.getSource();
		//Si se ha pulsado el botn cancelar sale sin guardar los cambios
		if (implicado==botonCancelar)
		{
			setVisible(false);
		}
		
		//Si se ha pulsado el botn agregar comprobar si el usuario ha introducido datos (y si son vlidos) en los campos de texto
		else if (implicado==botonAgregar)
		{
			String cadenaEstacionUnica=estacion.getText();
			String cadenaPgEstacion=valorPgEstacion.getText();
			
			String cadenaInt1=intervalo1.getText();
			String cadenaInt2=intervalo2.getText();
			String cadenaPgIntervalo=valorPgIntervalo.getText();
			
			avisos.setText("");
			
			//Si hay datos en los dos campos de texto de asignacin de PG a una estacin concreta comprueba la validez de los datos y en caso afirmativo realiza la asignacin	
			if (cadenaEstacionUnica.compareTo("")!=0 && cadenaPgEstacion.compareTo("")!=0)
			{
				int numeroEstacion;
				Double pgEstacion;
				try
				{
					numeroEstacion=Integer.parseInt(cadenaEstacionUnica);
					if (numeroEstacion<1 || numeroEstacion>listaPg.length)
					{
						avisos.setText("El nmero de estacin no es vlido");
						return;
					}
					
					
				} catch(NumberFormatException ex)
				{
					avisos.setText("El nmero de estacin no es vlido");
					return;
				}
				
				try
				{
					pgEstacion=Double.parseDouble(cadenaPgEstacion);
					if (pgEstacion<0 || pgEstacion>1) 
					{
						avisos.setText("P.G. debe estar entre 0.0 y 1.0");
						return;
					}
				
				} catch(NumberFormatException ex)
				{
					avisos.setText("El valor de P.G. no es vlido");
					return;
				}
				
				
				int columna=(tabla.getColumnName(0).compareTo("ESTACIN")==0? 1: 0); //Por si usuario cambia el orden de las columnas
				tabla.setValueAt(pgEstacion, numeroEstacion-1, columna);
				estacion.setText("");
				valorPgEstacion.setText("");
				
			}
			else
			{
				//resetea los campos de texto
				estacion.setText("");
				valorPgEstacion.setText("");
			}
			
			//Si hay datos en los tres campos de texto de asignacin de PG a un rango de estaciones comprueba la validez de los datos y en caso afirmativo realiza la asignacin
			if (cadenaInt1.compareTo("")!=0 && cadenaInt2.compareTo("")!=0 && cadenaPgIntervalo.compareTo("")!=0)
			{
				int inicio, fin;
				Double pgIntervalo;
				try
				{
					inicio=Integer.parseInt(cadenaInt1);
					fin=Integer.parseInt(cadenaInt2);
					if (inicio<1 || inicio>listaPg.length|| fin<1 || fin> listaPg.length)
					{
						avisos.setText("El intervalo de estaciones no es vlido");
						return;
					}
					
					
				} catch(NumberFormatException ex)
				{
					avisos.setText("El intervalo de estaciones no es vlido");
					return;
				}
				
				try
				{
					pgIntervalo=Double.parseDouble(cadenaPgIntervalo);
					if (pgIntervalo<0 || pgIntervalo>1) 
					{
						avisos.setText("P.G. debe estar entre 0.0 y 1.0");
						return;
					}
					
				} catch(NumberFormatException ex)
				{
					avisos.setText("El valor de P.G. no es vlido");
					return;
				}
				
				//Determina cul es la columna de PG (por si el usuario hubiera intercambiado la posicin de las columnas al pulsar y arrastrar el ratn) para asgnarle el valor correspondiente
				int columna=(tabla.getColumnName(0).compareTo("ESTACIN")==0? 1: 0);
					for(int i=Math.min(inicio, fin)-1; i<Math.max(inicio, fin); i++) tabla.setValueAt(pgIntervalo, i, columna);

				//resetea los campos de texto
				intervalo1.setText("");
				intervalo2.setText("");
				valorPgIntervalo.setText("");
				
			}
			else 
			{
				//resetea los campos detexto
				intervalo1.setText("");
				intervalo2.setText("");
				valorPgIntervalo.setText("");
			}
			
			
		}
		
		//Si se ha pulsado el botn aceptar asigna los valores almacenados en la tabla a las estaciones de la red
		else if (implicado==botonAceptar)
		{
			int columna=(tabla.getColumnName(0).compareTo("ESTACIN")==0? 1: 0); //Por si usuario cambia el orden de las columnas
			try
			{
				for(int i=0; i<listaPg.length; i++)
					listaPg[i]=(Double)tabla.getValueAt(i, columna);
				panelNuevaSimulacion.setArrayPg(listaPg);
				setVisible(false);
				panelNuevaSimulacion.setVisible(true);
				
			} catch(NumberFormatException ex)
			{
				ex.printStackTrace();
			}
		}
	}
	
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	public void mouseClicked(MouseEvent e){}

}

