
//CLASE QUE EMPLEADA POR BloqueGrafico PARA REPRESENTAR GRFICAMENTE LAS CELDAS
public class CeldaGrafica
{
	private Celda celda; //Celda (lgica) asociada a esta celda grfica
	private int x, y; //Coordenadas de esta celda grfica
	private boolean peticionRecienInsertada, datosRecienInsertados;
	
	//CONSTRUCTOR 1
	public CeldaGrafica(int x, int y)
	{
		celda=new Celda();
		this.x=x;
		this.y=y;
	}
	
	//Incrementa o decrementa la coordenada X (segn incremento sea un nmero positivo a negativo). Este mtodo se emplea para la animacin del movimiento de las celdas
	public void incrementarX(int incremento)
	{
		this.x=this.x+incremento;
	}
	
	//Establece los datos la celda asociada
	public void setDatos(Datos datos)
	{
		if (datos==null)
		{
			datosRecienInsertados=false;
			celda.setDatos(null);
		}
		else
		{
			celda.setDatos(datos.clonar());
			datosRecienInsertados=true;
		}
	}
	
	//Establece la celda asociada como ocupada
	public void setOcupada(boolean b)
	{
		celda.setOcupada(b);
	}
	
	//Modifica el bit peticin de la celda asociada
	public void setPeticion(boolean b)
	{
		celda.setPeticion(b);
	}
	
	//Establece la coordenada x
	public void setX(int x)
	{
		this.x=x;
	}
	
	//Establece la coordenada y
	public void setY(int y)
	{
		this.y=y;
	}
	
	//Devuelve la celda asociada
	public Celda getCelda()
	{
		return celda;
	}
	
	//Devuelve la coordenada x
	public int getX()
	{
		return x;
	}
	
	//Devuelve la coordenada y
	public int getY()
	{
		return y;
	}
	
	//Devuelve los datos de la celda asociada
	public Datos getDatos()
	{
		return celda.getDatos();
	}
	
	//comprueba si la celda asociada est ocupada
	public boolean getOcupada()
	{
		return celda.getOcupada();
	}
	
	//comprueba si la celda asociada est marcada con peticin
	public boolean getPeticion()
	{
		return celda.getPeticion();
	}
	
	//Para indicar si la celda asociada acaba de ser marcada con peticin en el C.A. que la contiene
	public void setPeticionRecienInsertada(boolean b)
	{
		peticionRecienInsertada=b;
	}
	
	//Indica si la celda asociada acaba de ser marcada con peticin
	public boolean getPeticionRecienInsertada()
	{
		return peticionRecienInsertada;
	}
	
	//Para indicar si la celda asociada ha sido ellenada con datos del C.A.
	public void setDatosRecienInsertados(boolean b)
	{
		datosRecienInsertados=b;
	}
	
	//Para indicar si la celda asociada ha sido ellenada con datos del C.A.
	public boolean getDatosRecienInsertados()
	{
		return datosRecienInsertados;
	}
}