import java.awt.*;
import javax.swing.*;
import java.awt.font.*;

//CLASE QUE IMPLEMETA LA GRFICA MLTIPLE VACA, QUE AVISA DEL MXIMO DE ESTACIONES SOPORTADAS
public class GraficaMultipleFantasma extends JPanel
{
	protected BloqueEstadisticas listener;
	protected int margenY=20;
	protected int origenX=65,origenY=margenY+260, TamEjeX=400,TamEjeY=220;
	protected Image background, labelX, labelY, titulo;
	protected int separadores=10;
	
	public GraficaMultipleFantasma(Image background, Image labelX, Image labelY, Image titulo)
	{
		this.background=background;
		this.labelX=labelX;
		this.labelY=labelY;
		this.titulo=titulo;
		
		Dimension dim=new Dimension(background.getWidth(this),background.getHeight(this)+margenY);
		setPreferredSize(dim);
		setMaximumSize(dim);
		setMinimumSize(dim);
	}


	public void paintComponent( Graphics g )
	{
		super.paintComponent(g);
		
		g.drawImage(background, 0, margenY, this);		
		g.drawImage(titulo, (background.getWidth(this)-titulo.getWidth(this))/2, margenY+7, this);
		g.drawImage(labelX, (background.getWidth(this)-labelX.getWidth(this))/2, margenY+background.getHeight(this)-20, this);
		g.drawImage(labelY,10, margenY+(background.getHeight(this)-labelY.getHeight(this))/2, this);
		g.setColor(Color.black);
		
		
		g.setColor(Color.white);
		g.fillRect(origenX, origenY-TamEjeY,TamEjeX,TamEjeY);
		g.setColor(Color.black);
		g.drawLine(origenX, origenY-TamEjeY, origenX,origenY);//pinta ejes
		g.drawLine(origenX, origenY, origenX+TamEjeX,origenY);
		
		g.setColor(Color.lightGray);
		g.drawLine(origenX+TamEjeX, origenY-TamEjeY, origenX+TamEjeX,origenY);
		g.drawLine(origenX, origenY-TamEjeY, origenX+TamEjeX,origenY-TamEjeY);
		

		for(int i=1;i<=separadores;i++)
		{
			//pinta separadores de ejes
			g.drawLine(origenX-3, origenY-(int)Math.round(i*TamEjeY/separadores) , origenX+2, origenY-(int)Math.round(i*TamEjeY/separadores) );	
			g.drawLine(origenX+(int)Math.round(i*TamEjeX/separadores), origenY-2 , origenX+(int)Math.round(i*TamEjeX/separadores), origenY+3 );
		}
		
		g.setColor(new Color(0,0,0));
		g.drawLine(origenX, origenY-TamEjeY, origenX,origenY);
		g.drawLine(origenX, origenY, origenX+TamEjeX,origenY);
		
		
		Graphics2D g2d = (Graphics2D)g;
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		Font fuente=new Font("Verdana", Font.PLAIN, 18);
		g2d.setFont(fuente);
		g2d.setColor(Color.red);
		
		FontRenderContext frc = g2d.getFontRenderContext();
		
		String linea1="NO DISPONIBLE PARA SIMULACIONES";
		String linea2="DE MS DE 10 ESTACIONES";
		LineMetrics linemetrics = fuente.getLineMetrics(linea1, frc);
		int largoLinea1=(int)fuente.getStringBounds(linea1, frc).getWidth();	
		int altoLinea1=(int)fuente.getStringBounds(linea1, frc).getHeight();	
		
		linemetrics = fuente.getLineMetrics(linea2, frc);
		int largoLinea2=(int)fuente.getStringBounds(linea2, frc).getWidth();	
		int altoLinea2=(int)fuente.getStringBounds(linea2, frc).getHeight();	
		
		g2d.drawString("NO DISPONIBLE PARA SIMULACIONES", origenX+(TamEjeX-largoLinea1)/2,120);
		g2d.drawString("DE MS DE 10 ESTACIONES", origenX+(TamEjeX-largoLinea2)/2,120+altoLinea1+5);	
	}

	
}




