import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;


//CLASE DE IMPLEMENTA EL PANEL DE "CRDITOS" DE LA APLICACIN
public class PanelAcercaDeDQDB extends JDialog
{	
	//CONSTRUCTOR
	public PanelAcercaDeDQDB(JFrame owner)
	{

		super(owner, "Acerca de DQDB Sim", true);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setResizable(false);
		PanelAuxiliar panel=new PanelAuxiliar("acercaDe.png");
		setSize(panel.getPreferredSize());
		getContentPane().add(panel);
	}

}

//Clase auxiliar empleada por la clase PanelAcercaDeDQDB para mostrar el nmero de versin del simulador
class PanelAuxiliar extends JPanel
{
	private Image fondo;
	private String versionDQDBSim=Constantes.versionDQDBSim;
	public PanelAuxiliar(String nombreDeLaImagen)
	{
		super();
		setOpaque(false);
		
		this.versionDQDBSim=versionDQDBSim;
		fondo=CargadorDeImagenes.getCargador().getImagen(nombreDeLaImagen);
		setPreferredSize(new Dimension(fondo.getWidth(this),fondo.getHeight(this)));
	}
	
	//Sobreescribe el mtodo paintComponent de JPanel para suaviar el texto
	//Escribe el nmero de versin especificado en la clase Constantes
	public void paintComponent(Graphics g)
	{
		if (g instanceof Graphics2D)
		{
      		Graphics2D g2 = (Graphics2D)g;
      		Map<Object, Object> rMap = new HashMap<Object, Object>();
        	Object key = RenderingHints.KEY_ANTIALIASING;
        	Object value = RenderingHints.VALUE_ANTIALIAS_ON;
        	rMap.put(key, value);
        	g2.addRenderingHints(rMap);
    	}

		g.drawImage(fondo,0,0, this);
		
		g.setColor(new Color(51,102,153));
		g.setFont(new Font("ARIAL", Font.BOLD, 20));
		g.drawString(versionDQDBSim, 330, 50);
		super.paintComponent(g);
	}

}