import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.DefaultStyledDocument;

//CLASE QUE IMPLEMENTA LA VENTANA DE CONFIGURACION DE NUEVA SIMULACION
public class PanelNuevaSimulacion extends JDialog implements MouseListener, Runnable
{
	private double pg;
	private int estaciones, version;
	private double [] arrayPg;
	
	private Label avisos;
	private InterfazGrafica interfaz;
	
	private ImageIcon iconoVersion1, iconoVersion2, iconoVersion3, iconoVersion4, iconoHomogenea, iconoHeterogenea;
	private Checkbox checkboxVersion1,checkboxVersion2, checkboxVersion3, checkboxVersion4, checkboxHomogenea, checkboxHeterogenea;
	private Boton botonGenerar, botonCancelar;
	private TextFieldNumerico textfieldEstaciones, textfieldPg, textfieldSemilla;
	

	//CONSTRUCTOR
	public  PanelNuevaSimulacion(InterfazGrafica interfaz,boolean modal)
	{	
		super(new JFrame(), "Configuracin del Sistema a Simular", true);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

		PanelConFondo panel=new PanelConFondo("panelGenerar3.gif");
		panel.setBackground(new Color(176, 176, 176));
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		getContentPane().add(panel);

		setSize(new Dimension(416,252));
		
		avisos=new Label("");
		avisos.setForeground(Color.red);
		version=Constantes.VERSION_INICIAL;
		pg=Constantes.PG_INICIAL;
		estaciones=Constantes.NUMERO_ESTACIONES_INICIAL;
		arrayPg=null;
		
		checkboxVersion1=new Checkbox((iconoVersion1=CargadorDeImagenes.getCargador().getIcono("botonVersion1.gif")), CargadorDeImagenes.getCargador().getIcono("botonVersion1Selected.gif"), false, this);
		checkboxVersion2=new Checkbox((iconoVersion2=CargadorDeImagenes.getCargador().getIcono("botonVersion2.gif")), CargadorDeImagenes.getCargador().getIcono("botonVersion2Selected.gif"), false, this);
		checkboxVersion3=new Checkbox((iconoVersion3=CargadorDeImagenes.getCargador().getIcono("botonVersion3.gif")), CargadorDeImagenes.getCargador().getIcono("botonVersion3Selected.gif"), false, this);
		checkboxVersion4=new Checkbox((iconoVersion4=CargadorDeImagenes.getCargador().getIcono("botonVersion4.gif")), CargadorDeImagenes.getCargador().getIcono("botonVersion4Selected.gif"), false, this);
		checkboxHomogenea=new Checkbox((iconoHomogenea=CargadorDeImagenes.getCargador().getIcono("botonPgHomogenea.gif")), CargadorDeImagenes.getCargador().getIcono("botonPgHomogeneaSelected.gif"), true, this);
		checkboxHeterogenea=new Checkbox((iconoHeterogenea=CargadorDeImagenes.getCargador().getIcono("botonPgHeterogenea.gif")), CargadorDeImagenes.getCargador().getIcono("botonPgHeterogeneaSelected.gif"), false, this);
		botonGenerar=new Boton(CargadorDeImagenes.getCargador().getIcono("botonAceptar2.gif"), CargadorDeImagenes.getCargador().getIcono("botonAceptarPressed2.gif"), this);
		botonCancelar=new Boton(CargadorDeImagenes.getCargador().getIcono("botonCancelar2.gif"), CargadorDeImagenes.getCargador().getIcono("botonCancelarPressed2.gif"), this);
		ButtonGroup grupoVersion=new ButtonGroup();
		grupoVersion.add(checkboxVersion1);
		grupoVersion.add(checkboxVersion2);
		grupoVersion.add(checkboxVersion3);
		grupoVersion.add(checkboxVersion4);
		
		ButtonGroup grupoPg=new ButtonGroup();
		grupoPg.add(checkboxHomogenea);
		grupoPg.add(checkboxHeterogenea);
		
		if(version==1) checkboxVersion1.setSelected(true);
		else if(version==2) checkboxVersion2.setSelected(true);
		else if(version==3) checkboxVersion3.setSelected(true);
		else if(version==4) checkboxVersion4.setSelected(true);
		
		
		this.interfaz=interfaz;
		
		textfieldEstaciones=new TextFieldNumerico(1,5);
		textfieldEstaciones.setText(""+estaciones);
		textfieldEstaciones.setHorizontalAlignment(SwingConstants.CENTER);
		
		textfieldPg=new TextFieldNumerico(2);
		textfieldPg.setText(""+pg);
		textfieldPg.setHorizontalAlignment(SwingConstants.CENTER);
		
		textfieldSemilla=new TextFieldNumerico(1,5);
		textfieldSemilla.setText(""+((int)(Math.random()*10000)));
		Dimension dim=new Dimension(80,25);
		textfieldEstaciones.setPreferredSize(dim);
		textfieldEstaciones.setMaximumSize(dim);
		textfieldEstaciones.setMinimumSize(dim);
		dim=new Dimension(70,22);
		textfieldPg.setPreferredSize(dim);
		textfieldPg.setMaximumSize(dim);
		textfieldPg.setMinimumSize(dim);
		
		dim=new Dimension(70,22);
		textfieldSemilla.setPreferredSize(dim);
		textfieldSemilla.setMaximumSize(dim);
		textfieldSemilla.setMinimumSize(dim);

		Font font=new Font("Arial", Font.BOLD, 17);
		textfieldPg.setFont(font);
		textfieldEstaciones.setFont(font);
		textfieldSemilla.setFont(font);
				
		textfieldEstaciones.setAlignmentX(0.5f);
		textfieldPg.setAlignmentX(0.3f);
		checkboxVersion1.setAlignmentX(0.5f);
		checkboxVersion2.setAlignmentX(0.5f);
		checkboxVersion3.setAlignmentX(0.5f);
		checkboxVersion4.setAlignmentX(0.5f);
		checkboxHomogenea.setAlignmentX(0.5f);
		checkboxHeterogenea.setAlignmentX(0.5f);
		avisos.setAlignmentX(0.5f);
		botonGenerar.setAlignmentX(0.5f);
		
	
		JPanel panel1=new JPanel();
		panel1.setLayout(new BoxLayout(panel1, BoxLayout.Y_AXIS));
		panel1.add(Box.createRigidArea(new Dimension(0,44)));
		panel1.add(textfieldEstaciones);
		panel1.add(Box.createRigidArea(new Dimension(0,47)));
		panel1.add(checkboxVersion1);
		panel1.add(checkboxVersion2);
		panel1.add(checkboxVersion3);
		panel1.add(checkboxVersion4);
		panel1.setAlignmentX(0f);
		panel1.setOpaque(false);
		
		dim=new Dimension(196,215);
		panel1.setPreferredSize(dim);
		panel1.setMaximumSize(dim);
		panel1.setMinimumSize(dim);
		
		JPanel panelSemilla=new JPanel();
		panelSemilla.setLayout(new BoxLayout(panelSemilla, BoxLayout.X_AXIS));
		panelSemilla.add(Box.createRigidArea(new Dimension(75,0)));
		panelSemilla.add(textfieldSemilla);
		panelSemilla.setOpaque(false);
		
		JPanel panelBot=new JPanel();
		panelBot.add(botonGenerar);
		panelBot.add(Box.createRigidArea(new Dimension(35,0)));
		panelBot.add(botonCancelar);
		panelBot.setOpaque(false);
		JPanel panel2=new JPanel();
		panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
		panel2.add(Box.createRigidArea(new Dimension(0,43)));
		panel2.add(checkboxHomogenea);
		panel2.add(Box.createRigidArea(new Dimension(0,6)));
		panel2.add(textfieldPg);
		panel2.add(Box.createRigidArea(new Dimension(0,3)));
		panel2.add(checkboxHeterogenea);
		panel2.add(Box.createRigidArea(new Dimension(0,10)));
		panel2.add(panelSemilla);
		panel2.add(Box.createRigidArea(new Dimension(0,1)));
		panel2.add(panelBot);
		panel2.add(Box.createRigidArea(new Dimension(0,3)));
		panel2.add(avisos);
		panel2.setAlignmentX(0f);	
		
		dim=new Dimension(196,220);
		panel2.setPreferredSize(dim);
		panel2.setMaximumSize(dim);
		panel2.setMinimumSize(dim);
		
		panel2.setOpaque(false);
		
		panel.add(panel1);
		panel.add(panel2);
	
		setResizable(false);
		setVisible(true);		
	}
	
	
	public void setArrayPg(double[] arrayPg)
	{
		this.arrayPg=arrayPg;
	}
	
	
	//Mtodos de la interfaz MouseListener
	public void mouseReleased(MouseEvent e)
	{
		Object implicado=e.getSource();
		
		//Si se ha pulsado el botn "Generar" se comprueba la validez delos datos introducidos por el usuario, y en caso afirmativo se genera la red
		if (implicado==botonGenerar)
		{
			int semilla=10;
	
			
			try
			{ 
				String stringEstaciones=textfieldEstaciones.getText();
				estaciones=Integer.parseInt(stringEstaciones);	
						
			} catch (NumberFormatException ex) 
			{
				avisos.setText("Estaciones: nmero invlido");
				return;
			}
			
							
			if (estaciones<2 || estaciones>Constantes.NUMERO_ESTACIONES_MAXIMO) 
			{
				avisos.setText("Mximo permitido: "+Constantes.NUMERO_ESTACIONES_MAXIMO+" est.");
				return;
			}

			try
			{
				semilla=Integer.parseInt(textfieldSemilla.getText());	
			}
			catch(NumberFormatException ex)
			{
				avisos.setText("La semilla no es vlida.");
				return;
			}
			
			if (checkboxHomogenea.isSelected())
			{

				try
				{
	
					String stringPg=textfieldPg.getText();
					pg=Double.parseDouble(stringPg);
				}
				
				catch (NumberFormatException ex)	
				{
					avisos.setText("PG: nmero invlido");
					return;
				}
			}
					
			if (pg>1.0)
			{
				avisos.setText("PG debe estar en el intervalo [0,1]");
				return;
			}
			
			if(checkboxVersion1.isSelected()) version=1;
			else if(checkboxVersion2.isSelected()) version=2;
			else if(checkboxVersion3.isSelected()) version=3;
			else if(checkboxVersion4.isSelected()) version=4;
			
			GeneradorAleatorio.setSemilla(semilla);
			Thread threadGenerador=new Thread(this);
			threadGenerador.start();
			
		}
		
		//Si se ha pulsado el botn cancelar
		else if (implicado==botonCancelar)
		{
			setVisible(false);
		}
		
		//Si se ha seleccionado PG heterognea se muestra el panel de configuracin de PG
		else if (implicado==checkboxHeterogenea)
		{
			textfieldPg.setEditable(false); 
			setVisible(false);
			new PanelPg (this, estaciones);
		}
		
		//Si se ha seleccionado PG homognea
		else if (implicado==checkboxHomogenea)
		{	
			//Se borra el array de PGs heterogneas
			arrayPg=null;
		}
	}
	
	public void mousePressed(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}	
	public void mouseExited(MouseEvent e){}
	public void mouseClicked(MouseEvent e){}
	
	public void run()
	{
		avisos.setForeground(Color.blue);
		avisos.setText("Generando la red. Espere...");
		interfaz.generarSistema(version, estaciones,pg, arrayPg);
		setVisible(false);
	}
	
}








