
//CLASE QUE DEFINE CONSTANTES DE CONFIGURACIN POR DEFECTO DE LA APLICACIN
public class Constantes
{
	//Constantes de configuracin por defecto de la aplicacin
	public static String titulo="DQDB Sim";
	public static String versionDQDBSim="1.0";
	public static boolean borrarEventosAntiguos=false;
	public static boolean animarRecepcionDeCeldas=true;
	public static boolean ocultarInteriorTerminadores=true;
	public static boolean activarMensajesGraficos=true;	
	public static boolean avisarDeLimiteTextoExcedido=true;
	public static boolean verBarraBotones=true;
	public static int VERSION_INICIAL=1;
	public static int CAPACIDAD_AREA_TEXTO=10000;
	public static int NUMERO_ESTACIONES_INICIAL=5;
	public static int NUMERO_ESTACIONES_MAXIMO=1000;
	public static int NUMERO_ESTACIONES_MAXIMO_ESTADISTICAS=1000;
	public static double PG_INICIAL=0.5;	
	public static String directorioImagenes="imagenes/";
	public static String directorioAudio="audio/";
	public static int SLOTS_SIMULACION=50000;
	
	
	//Cdigo html empleado por los bloques "BloqueTeorico" y "BloqueAyuda". Modificando este cdigo es posible cambiar los contenidos de las secciones "MARCO TERICO" y "AYUDA"
	public static String marcoTeorico="<html><body><font size=\"30\"><div align=\"CENTER\"><table width=\"800\"  border=\"0\" cellpadding=\"0\" cellspacing=\"0\">  <tr>    <td colspan=\"2\"><img src=\""+getBase("logo.png")+"\"></td>  </tr>  <tr bgcolor=\"#FFFFFF\">    <td colspan=\"2\" valign=\"top\"> <h1>MARCO TE&Oacute;RICO</h1>      <hr>	<p></p>    <p>El funcionamiento de las redes metropolitanas DQDB (Distributed Queue Dual Bus) se basa de manera aproximada y simplificada en el siguiente modelo. </p>    <div align=\"center\"><img src=\""+getBase("fig1.png")+"\" width=\"446\" height=\"221\"></div>    <p>Cada estaci&oacute;n de la red est&aacute; conectada a dos buses, ambos con direcciones de transmisi&oacute;n opuestas. En la cabeza de cada bus, un generador de slots (ranuras temporales) emite un tren continuo de celdas vac&iacute;as (celda: unidad de datos de longitud fija). A su vez, cada celda recibida por una estaci&oacute;n, es retransmitida sobre el mismo bus en el siguiente slot temporal, de manera que el tren de celdas de cada bus sufre un retardo de un slot en cada estaci&oacute;n que atraviesa. Cuando una estaci&oacute;n desea transmitir, espera que le llegue una celda vac&iacute;a y deposita en ella los datos, pasando a transmitirla. Para simplificar el problema inicialmente se supondr&aacute; que efectivamente se escoge la primera celda que llega vac&iacute;a, no obstante en una red DQDB real no es as&iacute;. Por lo que en las sucesivas versiones se considerar&aacute;n dos alternativas: <br>          <br>          1) Se transmite sobre la primera celda que llega vac&iacute;a (de momento se supondr&aacute; que es as&iacute;).<br>          <br>          2) Se dejan pasar unas cuantas celdas vac&iacute;as antes de transmitir, utilizando el algoritmo de espera DQDB          que se describir&aacute; m&aacute;s adelante.<br>    </p>    <p> Obs&eacute;rvese que si la estaci&oacute;n destinataria est&aacute; m&aacute;s a la derecha que la emisora, entonces la transmisi&oacute;n se realizar&aacute; sobre el bus A (ver figura 1). En caso contrario, estaci&oacute;n destino a la izquierda, se transmitir&aacute; sobre el bus B. Esta celda ser&aacute; retransmitida por cada estaci&oacute;n a la que llegue, hasta llegar a la estaci&oacute;n destinataria. Cuando la estaci&oacute;n destinataria recibe la celda tiene dos alternativas:      	    <br>	    <br>a) retransmite la celda sin modificarla (se supondr&aacute; de momento que es as&iacute;).<br>	    <br>      b) &quot;borra&quot; la celda (p.e. la sustituye por una vac&iacute;a) permitiendo un mejor aprovechamiento de los buses.</p>      <p>En el protocolo DQDB original se opt&oacute; por la primera alternativa debido a razones de sencillez (se trata de una red de alta velocidad donde el tiempo entre celda y celda &quot;no da para mucho&quot;). No obstante, el est&aacute;ndar contempla un mecanismo de &quot;reciclado&quot; de celdas similar al que se estudiara aqu&iacute;.</p>	  	  	  <p>Cada celda consta de una cabecera y de un campo de datos (<a href=\"802.6-1994.pdf\">IEEE802.6</a> secci&oacute;n 6.2, p&aacute;g. 113). En nuestro modelo simplificado la cabecera estar&aacute; formada por los campos <b>Ocupada</b>, que permite distinguir las celdas que contienen datos de las vac&iacute;as, <b>Petici&oacute;n</b>, que permite a una estaci&oacute;n solicitar una celda vac&iacute;a para transmitir, <b>Origen</b>, para identificar la estaci&oacute;n origen de los datos y <b>Destino</b>, para identificar la estaci&oacute;n destino de los datos. El contenido del campo de datos es indiferente para nuestros prop&oacute;sitos.</p>	  <p> Han sido implementadas cuatro versiones diferentes, las cuales corresponden a las alternativas posibles en cuanto al algoritmo de espera de celdas vac&iacute;as y en cuanto al reciclado de celdas. Estas cuatro versiones (ordenadas seg&uacute;n complejidad creciente) se especifican m&aacute;s adelante. </p>	  <p>Dos de los par&aacute;metros cuyo estudio es m&aacute;s interesante son:<br>	    <br><ul><li><strong>TIEMPO MEDIO DE SERVICIO:</strong> Para cada estaci&oacute;n, medir el tiempo medio que transcurre desde que el Control de Acceso recibe del usuario una unidad de datos hasta que consigue enviarla, en funci&oacute;n de la PG de los usuarios de cada estaci&oacute;n. Lo que permitir&aacute; observar, en condiciones de carga elevada, la influencia que la posici&oacute;n de la estaci&oacute;n tiene en este par&aacute;metro y la diferencia de comportamiento cuando se utilizan las alternativas (1) o (2).<br><br></li><li><strong>TR&Aacute;FICO CURSADO:</strong> El n&uacute;mero medio de celdas &quot;nuevas&quot; que admite la red por unidad de tiempo (esto es, el n&uacute;mero medio de Controles de Acceso que consiguen transmitir por cada slot). Lo que permitir&aacute; observar, en condiciones de carga elevada, la influencia del mecanismo de &quot;reciclado&quot; de celdas (alternativa b).</li></ul>    <h1><br><br><br><br>      VERSIONES DQDB </h1><hr>      <p> Para todas las versiones, modelaremos el inicio y el final del flujo de datos de los buses mediante los bloques &quot;Generador de Slots&quot; y &quot;Colector de Slots&quot;. El primero se encuentra al principio del bus y se encarga de generar y enviar una celda vac&iacute;a por el bus cada ST unidades de tiempo. El segundo se encuentra al final del bus y act&uacute;a como sumidero de celdas.</p>	<p>Estos bloques los encapsularemos dentro de otro bloque llamado &quot;Terminador&quot;, de forma que la red constar&aacute; de dos terminadores. El terminador izquierdo, que encapsular&aacute; el Generador de Slots del bus A y el Colector de Slots del bus B; y el terminador derecho, que encapsular&aacute; el Colector de Slots del bus A y el Generador de Slots del Bus, tal como muestra la siguiente figura: </p>	<div align=\"center\"><img src=\""+getBase("figTerminadores.png")+"\"></div>	<p>La estructura y comportamiento de estos tres bloques (Generador de slots, colector de slots y terminador) es la misma en las 4 versiones. </p>	<p>Por otra parte, cada estaci&oacute;n se compone de un bloque usuario, entidad generadora de datos, y dos controles de acceso, cada uno de ellos conectado a uno de los buses. &Eacute;stos &uacute;ltimos se encargan de gestionar el tr&aacute;fico del bus al que est&aacute;n conectados y de transmitir los datos generados por el usuario.</p>	<p>No obstante, el comportamiento de estos bloques y la forma en que interact&uacute;an va a depender de la versi&oacute;n de que se trate:</p>		 	 <h3> VERSI&Oacute;N 1: </h3>    <p>En esta primera aproximaci&oacute;n suponemos que se transmite sobre la primera celda en llegar vac&iacute;a y que no hay &quot;reciclado&quot; de celdas (alternativas (1) y (a)).</p>    <p>Cada estaci&oacute;n se modela seg&uacute;n el siguiente diagrama de bloques:</p>    <p align=\"center\"><img width=\"226\" height=\"206\" src=\""+getBase("figVersion1.png")+"\"></p>    <p>Asimismo, el comportamiento de los bloques que componen cada estaci&oacute;n ser&aacute; como se describe a continuaci&oacute;n: </p>    <p><br>      <strong>Bloque Usuario:</strong></p>    <p>Realiza en paralelo, de manera indefinida e independientemente, las siguientes dos tareas: </p>    <ul>      <li>Espera durante un tiempo aleatorio, escoge un identificador de estaci&oacute;n aleatoriamente, construye una unidad de datos con este identificador, y si es mayor que id lo emite por txA y si es menor por txB. </li>      <li>Siempre esta dispuesto a recibir por rxA o rxB (de momento solo act&uacute;a de sumidero de los datos que le entregan los controladores de acceso). </li>    </ul>    <p><br>      <strong>Bloque Control de Acceso:</strong></p>    <p>Repite de manera indefinida los siguientes pasos: </p>    <ul>      <li>Recibe una celda por <em>entrada</em> y si no es una celda vac&iacute;a, env&iacute;a inmediatamente sus datos al usuario por <em>rx</em>. </li>      <li>En el siguiente slot retransmite por <em>salida</em> la anterior celda sin modificarla.<br>    Nota: El siguiente slot vendr&aacute; marcado por la recepci&oacute;n de una nueva celda por el bus correspondiente. </li>      <li>Adem&aacute;s, en todo momento deber&aacute; estar listo para recibir una unidad de datos desde el usuario (por <em>tx</em>), en cuyo caso deber&aacute; depositar estos datos en la primera celda vac&iacute;a que le llegue y marcarla como ocupada. Mientras tenga una transmisi&oacute;n pendiente no aceptara mas peticiones desde <em>tx</em>. </li>    </ul>    <h3>&nbsp;</h3>    <h3> VERSI&Oacute;N 2</h3>    <p>En esta segunda aproximaci&oacute;n suponemos que se transmite sobre la primera celda en llegar vac&iacute;a y que hay &quot;reciclado&quot; de celdas (alternativas (1) y (b)).</p>    <p>Se trata de una modificaci&oacute;n de la versi&oacute;n 1 para incorporar el mecanismo de borrado de celdas, seg&uacute;n el siguiente diagrama de bloques: </p>    <p align=\"center\"><img width=\"226\" height=\"206\" src=\""+getBase("figVersion2.png")+"\"></p>    <p>El comportamiento de los bloques que componen cada estaci&oacute;n ser&aacute; viene dado por las siguientes especificaciones:</p>    <p><br>      <strong>Bloque Usuario:</strong><br>  <br>  Realiza en paralelo, de manera indefinida e independientemente, las siguientes dos tareas: </p>    <ul>      <li>Espera durante un tiempo aleatorio, escoge un identificador de estaci&oacute;n aleatoriamente, construye una unidad de datos con este identificador, y si es mayor que su id lo emite por <em>txA</em> y si es menor por <em>txB</em>. </li>      <li>Espera recibir por <em>rxA</em> o <em>rxB</em>. Si la unidad de datos recibida tiene identificador de destino igual al suyo propio, entonces emite inmediatamente una orden de &quot;borrado de celda&quot; hacia el controlador de acceso que corresponda (por <em>borrA</em> si recibi&oacute; por <em>rxA</em>, y por <em>borrB</em> en caso contrario). </li>    </ul>    <p><br>      <strong>Bloque Control de Acceso:</strong><br>  <br>  Repite de manera indefinida los siguientes pasos: </p>    <ul>      <li>Recibe una celda por <em>entrada</em> y si no es una celda vac&iacute;a, env&iacute;a inmediatamente sus datos al usuario por <em>rx</em>. </li>      <li>Si antes del siguiente slot no se ha recibido por <em>borr</em>, retransmite por <em>salida</em> la anterior celda sin modificarla. Si se ha recibido por <em>borr</em>, se &quot;reciclar&aacute;&quot; la celda marc&aacute;ndola como vac&iacute;a antes de retransmitirla (su destinatario era esta estaci&oacute;n, por tanto la &quot;reciclamos&quot;).<br>    Nota: El siguiente slot vendr&aacute; marcado por la recepci&oacute;n de una nueva celda por <em>entrada</em>. </li>      <li>Adem&aacute;s, en todo momento deber&aacute; estar listo para recibir una unidad de datos desde el usuario (por <em>tx</em>), en cuyo caso deber&aacute; depositar estos datos en la primera celda vac&iacute;a que le llegue y marcarla como ocupada. Mientras tenga una transmisi&oacute;n pendiente no aceptar&aacute; nuevas peticiones desde <em>tx</em>. </li>    </ul>    <p>&nbsp;</p>    <p>&nbsp;</p>  <h3>VERSI&Oacute;N 3</h3>    <p>En esta tercera aproximaci&oacute;n suponemos que se utiliza el algoritmo de espera DQDB y que no hay &quot;reciclado&quot; de celdas. (alternativas (2) y (a)).</p>    <p>Se trata nuevamente de una modificaci&oacute;n de la versi&oacute;n 1 para incorporar en los controladores de acceso el algoritmo de espera de celdas vac&iacute;as, seg&uacute;n el siguiente diagrama de bloques: </p>    <p align=\"center\"><img width=\"333\" height=\"202\" src=\""+getBase("figVersion3.png")+"\"></p>    <p>El comportamiento de los bloques que componen cada estaci&oacute;n ser&aacute; viene dado por las siguientes especificaciones:</p>    <p><br>      <strong>Bloque Usuario:</strong><br>  <br>  Realiza en paralelo, de manera indefinida e independientemente, las siguientes dos tareas: </p>    <ul>      <li>Espera durante un tiempo aleatorio, escoge un identificador de estaci&oacute;n aleatoriamente, construye una unidad de datos con este identificador, y si es mayor que su id lo emite por <em>txA</em> y si es menor por txB. </li>      <li>Siempre esta dispuesto a recibir por <em>rxA</em> o <em>rxB</em> (de momento solo act&uacute;a de sumidero de los datos que le entregan los controladores de acceso). </li>    </ul>    <p><br>      <strong>Bloque Control de Acceso:</strong><br></p>  <p>Repite de manera indefinida los siguientes pasos: </p>                         <ul>          <li>Recibe una celda por <em>entrada:</em>            <ul>              <li><em>S</em>i est&aacute; ocupada env&iacute;a inmediatamente sus datos al usuario por <em>rx</em>.</li>              <li>Si est&aacute; vac&iacute;a y el contador CD es mayor que cero lo decrementar&aacute; en una unidad; si por el contrario el contador CD es menor o igual que cero y no tiene datos pendientes incrementar&aacute; el contador de celdas vac&iacute;as; si por el contrario tiene datos pendientes los insertar&aacute; en la celda y la marcar&aacute; como ocupada (A partir de este momento el control de acceso puede aceptar nuevos datos desde <em>rx</em>). Nota: El siguiente slot vendr&aacute; marcado por la recepci&oacute;n de una nueva celda por el bus correspondiente. </li>              <li>Si la celda recibida est&aacute; marcada con petici&oacute;n incrementa su contador de peticiones (contador RC asociado al bus opuesto); si no est&aacute; marcada con petici&oacute;n y el contador de peticiones pendientes de env&iacute;o es mayor que cero, marcar&aacute; la celda con petici&oacute;n y decrementar&aacute; dicho contador en una unidad.</li>            </ul>          </li>                  <li>Adem&aacute;s, en todo momento deber&aacute; estar listo para recibir una unidad de datos desde el usuario (por <em>tx</em>). Mientras tenga datos pendientes no aceptar&aacute; nuevas peticiones desde <em>tx</em>. Al aceptar datos recibidos por <em>tx</em>, solicitar&aacute; por <em>pet</em> al otro controlador que env&iacute;e una petici&oacute;n &quot;r&iacute;o arriba&quot;. &Eacute;ste a su vez, cuando reciba dicha se&ntilde;al incrementar&aacute; su contador de peticiones pendientes de env&iacute;o y le pasar&aacute; por <em>rc</em> el valor de su contador RC, valor que se utilizar&aacute; para inicializar el contador de cuenta atr&aacute;s CD, seg&uacute;n la expresi&oacute;n: CD=RC(Control de Acceso Opuesto)-VAC&Iacute;AS. A partir de ese momento, CD contiene el n&uacute;mero de estaciones que hay por delante del control de acceso en la cola, es decir, el n&uacute;mero de celdas vac&iacute;as que deber&aacute; dejar pasar antes de transmitir. <br>            <br>            <br>          </li>        </ul>      <h3>VERSI&Oacute;N 4 </h3>    <p>En esta cuarta aproximaci&oacute;n suponemos que se utiliza el algoritmo de espera DQDB y que hay &quot;reciclado&quot; de celdas. (alternativas (2) y (b)).</p>    <p>Se trata de una modificaci&oacute;n de la versi&oacute;n 3 para Consiste en la versi&oacute;n 3 modificada para incorporar el mecanismo de reciclado de celdas., seg&uacute;n el siguiente diagrama de bloques: </p>    <p align=\"center\"><img width=\"362\" height=\"205\" src=\""+getBase("figVersion4.png")+"\"></p>    <p>El comportamiento de los bloques que componen cada estaci&oacute;n ser&aacute; viene dado por las siguientes especificaciones:</p>    <p><br>      <strong>Bloque Usuario:</strong><br>  <br>  Realiza en paralelo, de manera indefinida e independientemente, las siguientes dos tareas: </p>    <ul>      <li>Espera durante un tiempo aleatorio, escoge un identificador de estaci&oacute;n aleatoriamente, construye una unidad de datos con este identificador, y si es mayor que id lo emite por <em>txA</em> y si es menor por <em>txB</em>. </li>      <li>Espera recibir por <em>rxA</em> o <em>rxB</em>. Si la unidad de datos recibida tiene identificador de destino igual al suyo propio, entonces emite inmediatamente una orden de &quot;borrado de celda&quot; hacia el controlador de acceso que corresponda (por <em>borrA</em> si recibi&oacute; por <em>rxA</em>, y por <em>borrB</em> en caso contrario). </li>    </ul>    <p>&nbsp;</p>    <p><strong>Bloque Control de Acceso:</strong></p>    <p>Repite de manera indefinida los siguientes pasos: </p>                         <ul>          <li>Recibe una celda por <em>entrada:</em>            <ul>              <li><em>S</em>i est&aacute; ocupada env&iacute;a inmediatamente sus datos al usuario por <em>rx</em>.</li>              <li>Si est&aacute; vac&iacute;a y el contador CD es mayor que cero lo decrementar&aacute; en una unidad; si por el contrario el contador CD es menor o igual que cero y no tiene datos pendientes incrementar&aacute; el contador de celdas vac&iacute;as; si por el contrario tiene datos pendientes los insertar&aacute; en la celda y la marcar&aacute; como ocupada (A partir de este momento el control de acceso puede aceptar nuevos datos desde <em>rx</em>). Nota: El siguiente slot vendr&aacute; marcado por la recepci&oacute;n de una nueva celda por el bus correspondiente. </li>              <li>Si la celda recibida est&aacute; marcada con petici&oacute;n incrementa su contador de peticiones (contador RC asociado al bus opuesto); si no est&aacute; marcada con petici&oacute;n y el contador de peticiones pendientes de env&iacute;o es mayor que cero, marcar&aacute; la celda con petici&oacute;n y decrementar&aacute; dicho contador en una unidad.</li>            </ul>          </li>          <li>Si antes del siguiente slot no se ha recibido por <em>borr</em>, retransmite por <em>salida</em> la anterior celda sin modificarla. Si se ha recibido por <em>borr</em>, se &quot;reciclar&aacute;&quot; la celda marc&aacute;ndola como vac&iacute;a antes de retransmitirla (su destinatario era esta estaci&oacute;n, por tanto la &quot;reciclamos&quot;).<br>            Nota: El siguiente slot vendr&aacute; marcado por la recepci&oacute;n de una nueva celda por <em>entrada</em>. </li>          <li>Adem&aacute;s, en todo momento deber&aacute; estar listo para recibir una unidad de datos desde el usuario (por <em>tx</em>). Mientras tenga datos pendientes no aceptar&aacute; nuevas peticiones desde <em>tx</em>. Al aceptar datos recibidos por <em>tx</em>, solicitar&aacute; por <em>pet</em> al otro controlador que env&iacute;e una petici&oacute;n &quot;r&iacute;o arriba&quot;. &Eacute;ste a su vez, cuando reciba dicha se&ntilde;al incrementar&aacute; su contador de peticiones pendientes de env&iacute;o y le pasar&aacute; por <em>rc</em> el valor de su contador RC, valor que se utilizar&aacute; para inicializar el contador de cuenta atr&aacute;s CD, seg&uacute;n la expresi&oacute;n: CD=RC(Control de Acceso Opuesto)-VAC&Iacute;AS. A partir de ese momento, CD contiene el n&uacute;mero de estaciones que hay por delante del control de acceso en la cola, es decir, el n&uacute;mero de celdas vac&iacute;as que deber&aacute; dejar pasar antes de transmitir. </li>        </ul>      </p>	  <br>	  <br>     	  <h2><strong>Bibliograf&iacute;a y referencias:</strong></h2><hr>		<p>Recomendaciones IEEE (The Institute of Electrical and Electronics Engineers):</p>	<ul>	  <li><a href=\"802.6-1994.pdf\">802.6-1994.pdf</a>: ANSI/IEEE Std 802.6, 1994 Edition, Part 6: Distributed Queue Dual Bus (DQDB) access method and physical layer specifications;.</li>    <li>      <a href=\"802.6j-1995.pdf\">802.6j-1995.pdf</a>: IEEE Std 802.6j-1995, Supplement to Distributed Queue Dual Bus (DQDB) access method and physical layer specifications;.   </li></ul><hr><p><br>DQDB Sim. Simulador did&aacute;ctico de redes DQDB <br>Autor: <a href=\"mailto:MartinezRojo@hotmail.com\">Antonio Manuel Mart&iacute;nez Rojo</a> <br><a href=\"http://www.upct.es\">UPCT</a>.</p></td></tr><tr><td width=\"327\">&nbsp;</td><td width=\"340\">&nbsp;</td>  </tr></table></div></font></body></html>";
	public static String ayuda="<html><body><div align=\"CENTER\"><img src=\""+getBase("guiaRapidaBotones3.gif")+"\" width=\"629\" height=\"261\"><br><br><br><b>CREAR, CONFIGURAR Y VER ESTAD&Iacute;STICAS DE LA RED</b><br><img src=\""+getBase("guiaRapida.gif")+"\" width=\"709\" height=\"594\"><br><img src=\""+getBase("guiaRapidaEstadisticas2.gif")+"\" width=\"709\" height=\"466\"><br><br></div></body></html>";
	
	//Mtodo que devuelve el directorio en el que se encuentran las imgenes empleadas por el cdigo html
	private static String getBase(String imagen)
	{
		for(int i=0; i<30; i++) System.out.println("");
		return CargadorDeImagenes.getCargador().getURL("AYUDA/"+imagen);
	}
}

    

